/****************************************************************************
#	 	GspcaGui:  Gspca/Spca5xx Grabber                            #
# 		Copyright (C) 2004 2005 2006 Michel Xhaard                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/ 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <string.h>
#include <pwd.h>

#include "colors/color.h"
#include "display.h"
#include "gui.h"

//#define PATHSPCA "icons/"
#define PATHSPCA "/usr/local/share/gspcagui/"
#define VFLAGS (SDL_ANYFORMAT | SDL_DOUBLEBUF | SDL_RESIZABLE | SDL_SWSURFACE)

static const char initscreen[] = PATHSPCA "spcagui.jpg";
static SDL_Overlay *imgload (const char* pathfile, SDL_Surface *screen);
extern struct passwd *mypasswd;	

video_screen_t *init_display(void)
{
	int size;
	int path_length;
	video_screen_t *myscreen = NULL;
	myscreen = (video_screen_t*) calloc(1,sizeof(video_screen_t));
	myscreen->title= (char *) calloc(1,120);
	myscreen->width = 640;
	myscreen->height = 480;
	myscreen->SDL_VideoFlags = VFLAGS;
	myscreen->screen = SDL_SetVideoMode(myscreen->width,myscreen->height , 0,
			 myscreen->SDL_VideoFlags);
			 if( !myscreen->screen){
			 printf("SDL_Screen error \n");
			 free(myscreen->title);
			 free(myscreen);
			 exit(1);
			 }
	myscreen->overlay = imgload (initscreen,myscreen->screen);
	myscreen->rectangle.x0 = myscreen->drect.x = 0;
	myscreen->rectangle.y0 = myscreen->drect.y = 0;
	myscreen->rectangle.x1 = myscreen->drect.w = myscreen->screen->w;
	myscreen->rectangle.y1 = myscreen->drect.h = myscreen->screen->h;
	myscreen->zoomon = NOZOOM;
	myscreen->rot = NOROT;
	myscreen->mode = GRABBER;
	myscreen->pictflag = 0;
	myscreen->screenshot.S = NULL;
	myscreen->screenshot.w = myscreen->screen->w;
	myscreen->screenshot.h = myscreen->screen->h;
	myscreen->screenshot.ow = myscreen->screen->w;
	myscreen->screenshot.oh = myscreen->screen->h;
	pthread_cond_init(&myscreen->screenshot.condition_cond,NULL);
        pthread_mutex_init(&myscreen->screenshot.condition_mutex,NULL);
	path_length = strlen(mypasswd->pw_dir);
	myscreen->path = malloc((path_length+1) *sizeof(char));
	strcpy(myscreen->path,mypasswd->pw_dir);
	size = myscreen->width * myscreen->height * 2;
	myscreen->intro_image.pix = malloc(size);
	myscreen->intro_image.w = myscreen->width;
	myscreen->intro_image.h = myscreen->height;
	SDL_LockYUVOverlay(myscreen->overlay);
	memcpy( myscreen->intro_image.pix,(unsigned char*)myscreen->overlay->pixels[0],size);
        SDL_UnlockYUVOverlay(myscreen->overlay);
return (myscreen);
}
	
int free_display(video_screen_t * display)
{
free(display->intro_image.pix);
SDL_FreeYUVOverlay(display->overlay);
free(display->title);
free(display->path);
close_sdlvideo();
pthread_cond_destroy(&display->screenshot.condition_cond);
pthread_mutex_destroy(&display->screenshot.condition_mutex);
free(display);	
}
int zoom_box (unsigned char *S,int *w, int *h , video_screen_t * display)
{ 
	int intw,inth, size,i;
	int xorg, yorg, xfin,yfin;
	int add;
	YUYV *Surf = NULL;
	YUYV *ptSurf = NULL;
	YUYV *Src =(YUYV*) S;
	xorg=(display->zoomrect.x0 >> 1)<< 1;
	yorg= (display->zoomrect.y0 >> 2)<<2;
	xfin=(display->zoomrect.x1 >> 1) << 1;
	yfin=(display->zoomrect.y1 >> 2) << 2;
	inth = yfin -yorg;
	intw = xfin -xorg;
	if(inth == *h && intw == *w)
		return NOZOOM;
	size = intw*inth >> 1;
	add = (yorg *(*w)+ xorg)>>1;
	Surf = (YUYV*) malloc(size*sizeof(YUYV));
	ptSurf = Surf;
	for (i = 0; i < inth; i++){
		memcpy(ptSurf,&Src[add],(size_t) intw*sizeof(YUYV)/2);
		add += ((*w)>>1);ptSurf += (intw >> 1);
	}
	memcpy(Src,Surf,(size_t) size*sizeof(YUYV));
	*w = intw; *h = inth;
	free(Surf);
	Surf = NULL;
return ZOOMON;	
}
int draw_box (unsigned char *S,int w, int h , video_screen_t * display)
{
        int intw,inth, size,i;
	int xorg, yorg, xfin,yfin;
	int add,addfin;
	unsigned char R,G,B;
	YUYV *Src =(YUYV*) S;
	 YUYV pixel;
	R = 235; G = 0; B = 0; 
        pixel.Y0= RGB24_TO_Y(R,G,B);
        pixel.Y1= RGB24_TO_Y(R,G,B);
        pixel.U0= YB_TO_U(B,pixel.Y0);
        pixel.V0= YR_TO_V(R,pixel.Y0);
	if (display->rectangle.x0 < display->rectangle.x1){
		xorg = display->rectangle.x0;
		xfin = display->rectangle.x1;
	} else {
		xorg = display->rectangle.x1;
		xfin = display->rectangle.x0;
		}
	intw = (xfin - xorg)*w/display->screen->w;
//inth = intw*display->screen->h/display->screen->w;
	if (display->rectangle.y0 < display->rectangle.y1){
		yorg = display->rectangle.y0;
		yfin = display->rectangle.y1;
	} else {
		yorg = display->rectangle.y1;
		yfin = display->rectangle.y0;
		}
	inth = (yfin -yorg)*h/display->screen->h;
	xorg = (xorg*w)/display->screen->w;
	yorg = (yorg*h)/display->screen->h;
	xfin = (xfin*w)/display->screen->w;
	yfin = (yfin*h)/display->screen->h;
//yfin = yorg + inth;	
	display->zoomrect.x0 = xorg;
	display->zoomrect.y0 = yorg;
	display->zoomrect.x1 = xfin;
	display->zoomrect.y1 = yfin;
	if(!inth || !intw || (inth == h) || (intw == w))
		return 0;
	add = ((yorg *w)+ xorg)>>1;
	addfin =((yfin *w)+ xorg)>>1;
	for(i = 0; i < intw/2; i++){
	memcpy(&Src[add +i],&pixel,sizeof(YUYV));
	memcpy(&Src[addfin +i],&pixel,sizeof(YUYV));
	}
	add = (((yorg+1) *w)+ xorg)>>1;
	addfin =(((yorg+1) *w)+ xfin)>>1;
	for(i=0; i<inth; i++){
	memcpy(&Src[add +i*w/2],&pixel,sizeof(YUYV));
	memcpy(&Src[addfin +i*w/2],&pixel,sizeof(YUYV));
	}
return 0;
}
			 
int process_display(unsigned char *S, int w, int h,int zoom, functrot filters, video_screen_t *display)
{
 int nw = w;
 int nh = h;
 int dwidth, dheight;
 int inrot;
 
 inrot = filters(S,&nw,&nh);
 if(inrot != display->rot){
 	display->rot = inrot;
 if( nw != display->width || nh != display->height){
    /* filters change the screen display */
    SDL_FreeYUVOverlay(display->overlay);
   display->height = nh; //actual h overlay surface
   display->width = nw; // actual w overlay surface
   dwidth = display->screen->h; // actual screen h size
   dheight = display->screen->w; //actual screen w size
   display->screen = SDL_SetVideoMode(dwidth,dheight , 0,
			 display->SDL_VideoFlags);
			 if( !display->screen){
			 printf("SDL_Screen error Filter change \n");
			 free(display->title);
			 free(display);
			 exit(1);
			 }
   display->overlay=SDL_CreateYUVOverlay(nw, nh,SDL_YUY2_OVERLAY, display->screen);
	display->drect.x = 0;
	display->drect.y = 0;
	display->drect.w = display->screen->w;
	display->drect.h = display->screen->h;
}
}

if(inrot == NOROT && zoom == NOZOOM){
 if( nw != display->width || nh != display->height){
    /* filters change the screen display */
    SDL_FreeYUVOverlay(display->overlay);
   display->height = nh; //actual h overlay surface
   display->width = nw; // actual w overlay surface
   dwidth = nw; // actual screen h size
   dheight = nh; //actual screen w size
   display->screen = SDL_SetVideoMode(dwidth,dheight , 0,
			 display->SDL_VideoFlags);
			 if( !display->screen){
			 printf("SDL_Screen error Not ROT \n");
			 free(display->title);
			 free(display);
			 exit(1);
			 }
   display->overlay=SDL_CreateYUVOverlay(nw, nh,SDL_YUY2_OVERLAY, display->screen);
	display->drect.x = 0;
	display->drect.y = 0;
	display->drect.w = display->screen->w;
	display->drect.h = display->screen->h;
}		
}
 if (zoom == ZOOMON)
 	zoom_box(S, &nw, &nh,display);
 if (display->zoomon != zoom){
	/* lets go to initialize zoom feature */
	display->zoomon = zoom;
	if (zoom == ZOOMON || zoom == NOZOOM){	
		display->height = nh; //actual h overlay surface
   		display->width = nw; // actual w overlay surface
		if (zoom == ZOOMON ){
		/* proper aspect ratio */
		 if(nw >= nh){
		   dwidth = display->screen->w;
		   dheight = (dwidth* nh)/nw ;
		 } else {
		   dheight = display->screen->h;
		   dwidth = (((dheight* nw)/nh) >> 1 ) << 1 ;
		 }
		} else { /*should be NOZOOM */
		 dwidth = nw;
		 dheight =nh;
		}
		display->screen = SDL_SetVideoMode(dwidth,dheight , 0,
			 display->SDL_VideoFlags);
			 if( !display->screen){
			 printf("SDL_Screen error Zoom ON\n");
			 free(display->title);
			 free(display);
			 exit(1);
			 }
		/* ****** */
		SDL_FreeYUVOverlay(display->overlay);
		display->overlay=SDL_CreateYUVOverlay(nw, nh,SDL_YUY2_OVERLAY, display->screen);
		display->drect.x = 0;
		display->drect.y = 0;
		display->drect.w = display->screen->w;
		display->drect.h = display->screen->h;
	}
 }
 
if(zoom == DRAWRECT || zoom == GETRECT) {
 	draw_box(S,nw,nh,display);
}

 	if(!pthread_mutex_trylock(&display->screenshot.condition_mutex)){
	    if(display->pictflag) {
 		display->screenshot.S = (unsigned char*) realloc(display->screenshot.S,nw*nh*2);
		display->screenshot.w = nw;
		display->screenshot.h = nh;
		display->screenshot.ow = display->screen->w;
		display->screenshot.oh = display->screen->h;
		memcpy(display->screenshot.S,S,nw*nh*2);
		pthread_cond_signal(&display->screenshot.condition_cond);
		}
	pthread_mutex_unlock(&display->screenshot.condition_mutex);
	}

SDL_LockYUVOverlay(display->overlay);
	memcpy((unsigned char*)display->overlay->pixels[0],S,nw*nh*2);
SDL_UnlockYUVOverlay(display->overlay);
return 0;
}

int resize_display(video_screen_t * display,int w,int h)
{
int wi = (w >> 1) << 1;
	display->screen = SDL_SetVideoMode( wi,h,0,display->SDL_VideoFlags);
	display->drect.w = display->screen->w;
	display->drect.h = display->screen->h;
	return 0;
}

void init_sdlall(void)
{	/* Initialize defaults, Video and Audio */
	if ((SDL_Init (SDL_INIT_VIDEO | SDL_INIT_TIMER | SDL_INIT_AUDIO | SDL_INIT_EVENTTHREAD) == -1)) {
		printf ("Could not initialize SDL: %s.\n", SDL_GetError ());
		exit (-1);
	}
	videoOk =1;
	atexit (SDL_Quit);	
}
void init_sdlvideo(void)
{	/* Initialize defaults, Video and Audio */
	if ((SDL_InitSubSystem (SDL_INIT_VIDEO ) == -1)) {
		printf ("Could not initialize SDL: %s.\n", SDL_GetError ());
		exit (-1);
	}
	videoOk = 1;
}
void close_sdlvideo(void)
{     SDL_QuitSubSystem (SDL_INIT_VIDEO ) ;
	videoOk = 0;
} 
static int file_size (FILE * f) 
{
int save_pos, size_of_file;
save_pos = ftell (f);
fseek (f, 0L, SEEK_END);
size_of_file = ftell (f);
fseek (f, save_pos, SEEK_SET);
return size_of_file;
}

static SDL_Overlay *imgload (const char* pathfile, SDL_Surface *screen)
{
	SDL_Overlay *Object;
	FILE *in_file;
	int width, height, depth, buffer_size;
	int err;
	unsigned char *inp = NULL;
	unsigned char *pp =NULL;
	in_file = fopen (pathfile , "rb");
	buffer_size = file_size (in_file);
	inp = (unsigned char *) malloc (buffer_size);
  	if (inp == NULL){
    	  error ("not enough memory");
	  fclose(in_file);
	  return NULL;
	  }
	  /* load whole file into the memory */
  	fread (inp, 1, buffer_size, in_file);
	fclose(in_file);
	width = 0; height = 0 ;
	if((err = jpeg_decode(&pp,inp,&width,&height)) < 0){
	error ("decoder jpeg fail");
	free(inp);
	if(pp) free(pp);
	return NULL;
	}
	free(inp);
	Object =
	SDL_CreateYUVOverlay(width, height,SDL_YUY2_OVERLAY, screen);
	SDL_LockYUVOverlay(Object);
	memcpy((unsigned char*)Object->pixels[0],pp,width*height*2);
	SDL_UnlockYUVOverlay(Object);
	free(pp);
	return (Object);
}
