/****************************************************************************
#	 	GspcaGui:  Gspca/Spca5xx Grabber                            #
# 		Copyright (C) 2004 2005 2006 Michel Xhaard                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/ 
#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>
#include <SDL/SDL_audio.h>
#include <SDL/SDL_timer.h>
#include <pthread.h>
#include "filter/rot.h"

extern int videoOk;


enum {
	NOZOOM = 0,
	DRAWRECT,
	GETRECT,
	ZOOMON,
};

typedef struct box {
	int x0;
	int y0;
	int x1;
	int y1;
} box ;

typedef struct video_intro {
	unsigned char * pix;
	int w;
	int h;	
} video_intro_t;

typedef struct picture_t {
        pthread_mutex_t condition_mutex;
        pthread_cond_t  condition_cond ; 	
	unsigned char *S;
	int w;
	int h;
	int ow;
	int oh;
} picture_t;

typedef struct video_screen {
	SDL_Surface *screen;
	SDL_Overlay *overlay;
	SDL_Rect drect;
	Uint32 SDL_VideoFlags;
	video_intro_t intro_image;
	int width; //last acquisition width
	int height; //last acquisition height
	box rectangle;
	box zoomrect;
	picture_t screenshot;
	int pictflag;
	char * path;
	int zoomon;
	int rot;
	char *title;
	int mode;
} video_screen_t;

void init_sdlall(void);
void init_sdlvideo(void); 
void close_sdlvideo(void);

video_screen_t *init_display(void);
int free_display(video_screen_t * display);
int zoom_box (unsigned char *S,int *w, int *h, video_screen_t * display);
int process_display(unsigned char *S, int w, int h,int zoom, functrot filters, video_screen_t * display);
int resize_display(video_screen_t * display,int w,int h);
