/***************************************************************************#
# jpegenc: library to encode a jpeg frame from various input palette.       #
# jpegenc works for embedded device without libjpeg                         #
#.                                                                          #
#   Copyright (C) 2005 Michel Xhaard                                        #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#  CREDIT:                                                                  #
# Original code from Nitin Gupta India (?)                                  #
#                                                                           #
#***************************************************************************/
#ifndef ENCODER_H
#define ENCODER_H
/********* Image_format know by the encoder *********************/
/* Native YUV Packet */
#define  FOUR_ZERO_ZERO 0	// Grey scale Y00 ...
#define  FOUR_TWO_ZERO 1	//Y00 Y01 Y10 Y11 Cb Cr
#define  FOUR_TWO_TWO 2		//Y00 Cb Y01 Cr
#define  FOUR_FOUR_FOUR 3	//Y00 Cb Cr Y01 Cb Cr
/****************************************************************/
unsigned int
rgb24trPyuv444(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);
unsigned int
rgb24trPyuv422(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);
unsigned int
rgb565trPyuv422(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);
unsigned int
rgb32trPyuv422(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);
unsigned int
rgb24trPyuv420(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);
unsigned int
rgb32trPyuv420(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);
unsigned int
rgb565trPyuv420(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);
unsigned int
rgb24trPyuv400(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);
unsigned int
yuv444PtrPyuv444(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);
unsigned int
yuv422PtrPyuv422(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);
unsigned int
yuv420PtrPyuv420(unsigned char * input_ptr, unsigned int image_width, unsigned int image_height);

unsigned int Pyuv400trPyuv400(unsigned char * input_ptr, unsigned int image_width,
		 unsigned int image_height);
unsigned int Pyuv420trPyuv420(unsigned char * input_ptr, unsigned int image_width,
		 unsigned int image_height);
unsigned int Pyuv422trPyuv422(unsigned char * input_ptr, unsigned int image_width,
		 unsigned int image_height);
unsigned int Pyuv444trPyuv444(unsigned char * input_ptr, unsigned int image_width,
		 unsigned int image_height);

		 		 	 
typedef unsigned int (*InSpaceToOut_f)(unsigned char * input_ptr,
		 unsigned int image_width, unsigned int image_height);
/*****************************************************************/
#define  BLOCK_SIZE 64
unsigned char Lqt[BLOCK_SIZE];
unsigned char Cqt[BLOCK_SIZE];
unsigned short ILqt[BLOCK_SIZE];
unsigned short ICqt[BLOCK_SIZE];
short Y1[BLOCK_SIZE];
short Y2[BLOCK_SIZE];
short Y3[BLOCK_SIZE];
short Y4[BLOCK_SIZE];
short CB[BLOCK_SIZE];
short CR[BLOCK_SIZE];
short Temp[BLOCK_SIZE];
int lcode;
unsigned short bitindex;
typedef struct JPEG_ENCODER_STRUCTURE {
	unsigned short mcu_width;
	unsigned short mcu_height;
	unsigned short horizontal_mcus;
	unsigned short vertical_mcus;
	unsigned short rows_in_bottom_mcus;
	unsigned short cols_in_right_mcus;
	unsigned short length_minus_mcu_width;
	unsigned short length_minus_width;
	unsigned short mcu_width_size;
	unsigned short offset;
	short ldc1;
	short ldc2;
	short ldc3;
	unsigned short rows;
	unsigned short cols;
	unsigned short incr;
} JPEG_ENCODER_STRUCTURE;
/* encode picture input to output 
quality factor 
converter used a function here RGB_2_422 for example
image_width image_height of the input picture
return the encoded size in Byte
*/
unsigned int 
encode_image(unsigned char * input_ptr, unsigned char * output_ptr,
		    unsigned int quality_factor,InSpaceToOut_f converter ,
		    unsigned int image_width, unsigned int image_height);
#endif				/* ENCODER_H */
