/****************************************************************************
#	 	GspcaGui:  Gspca/Spca5xx Grabber                            #
# 		Copyright (C) 2004 2005 2006 Michel Xhaard                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/ 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include "rot.h"
/* struct filter internal */
typedef struct moy_pict {
	YUYV *S;
	int w;
	int h;
	int coefmoy;
	int isinit;
	YUYV pixhight;
	YUYV pixlow;
	int Ucomp[256];
	int Vcomp[256];
	int UVcomp[256];
	unsigned char Ycomp[256];
} moy_pict_t;

moy_pict_t *filters = NULL;

int rot90 (unsigned char *S , int *width, int *height)
{
int y,x;
int base;
 int size;
YUYV *pixel = (YUYV *) S;
YUV *Sd = NULL;
int w= *width;
int h= *height;

Sd = (YUV*)calloc(w*h*3,1);
size = w*h;

for(y=h; y > 0; y--){
	for(x=0; x < size; x +=(h<<1),pixel++ ){
	base = x+y;
	Sd[base].Y0 = pixel->Y0;
	Sd[base].U0 = pixel->U0;
	Sd[base].V0 = pixel->V0;
	base+=h;
	Sd[base].Y0 = pixel->Y1;	
	Sd[base].U0 = pixel->U0;
	Sd[base].V0 = pixel->V0;
	}
}
pixel = (YUYV*) S;
for(y=0; y < size; y+=2, pixel++){
	pixel->Y0 = Sd[y].Y0;
	pixel->U0 = Sd[y].U0;
	pixel->Y1 = Sd[y+1].Y0;
	pixel->V0 = Sd[y].V0;
}

free (Sd);
*width=h;
*height=w; 
return ROT90;
} 

int rot270 (unsigned char *S , int *width, int *height)
 {
 int x,y;
 int base;
 int size;
YUYV *pixel = (YUYV *) S;
YUV *Sd = NULL;
int w= *width;
int h= *height;
Sd = (YUV*)calloc(w*h*3,1);
if (!Sd) {
	printf("Cannot get the surface from calloc \n");
	return;
}
size = w*h;
for(y=0;y <h; y++){
	for(x=0; x < size ; x+=(h<<1),pixel++){
	base = size-x+y;
	    if(base < size) {
	        Sd[base].Y0 = pixel->Y0;
	        Sd[base].U0 = pixel->U0;
	        Sd[base].V0 = pixel->V0;
	        base-=h;
	        Sd[base].Y0 = pixel->Y1;	
	        Sd[base].U0 = pixel->U0;
	        Sd[base].V0 = pixel->V0;
	} 
	}
}

pixel = (YUYV*) S;
for(y=0; y < size; y+=2,pixel++){
	pixel->Y0 = Sd[y].Y0;
	pixel->U0 = Sd[y].U0;
	pixel->Y1 = Sd[y+1].Y0;
	pixel->V0 = Sd[y].V0;
}

free (Sd);
*width=h;
*height=w; 
return ROT270;
}
int flipy (unsigned char *S , int *width, int *height)
 {
 int y;
 int size;
YUYV *pixel = (YUYV *) S;
YUYV *Sd = NULL;
int w= *width/2;
int h= *height;

Sd = (YUYV*) calloc(w*sizeof(YUYV),1);
size = w*sizeof(YUYV);

for(y=0; y < h/2; y++){
	memcpy(Sd,&pixel[y*w],size);	
	memcpy(&pixel[y*w],&pixel[(h-y)*w],size);
	memcpy(&pixel[(h-y)*w],Sd,size);
}

free (Sd);
return FLIPY;
}

#define TWIST(a) tmp =a.Y0; a.Y0 = a.Y1; a.Y1 = tmp
	
int flipx (unsigned char *S , int *width, int *height)
 {
 int y,x;
 int size;
YUYV *pixel = (YUYV *) S;
YUYV Sd ;
unsigned char tmp;
int w= *width/2;
int h= *height;
size = sizeof(YUYV);

for(y=0; y < h ; y++){
	for(x=0;x < w/2; x++){
		memcpy(&Sd,&pixel[y*w+x],size);
		TWIST(Sd);	
		memcpy(&pixel[y*w+x],&pixel[(w*y)+w-x],size);
		TWIST(pixel[y*w+x]);
		memcpy(&pixel[(w*y)+w-x],&Sd,size);
	}
}
return FLIPX;
}

int rot180 (unsigned char *S , int *width, int *height)
 {
 int y,x;
 int size;
YUYV *pixel = (YUYV *) S;
YUYV Sd ;
unsigned char tmp;
int w= *width/2;
int h= *height;
size = sizeof(YUYV);

for(y=0; y <= h/2 ; y++){
	for(x=0;x < w; x++){
		if((x==w/2) && (y == h/2)) break;
		memcpy(&Sd,&pixel[y*w+x],size);
		TWIST(Sd);	
		memcpy(&pixel[y*w+x],&pixel[(w*(h-y))+w-x],size);
		TWIST(pixel[y*w+x]);
		memcpy(&pixel[(w*(h-y))+w-x],&Sd,size);
	}
}
return ROT180;
}

int dummyrot (unsigned char *S , int *width, int *height)
{
return NOROT;
}
#define CLIP(color) (unsigned char)((color>0xFF)?0xff:((color<0)?0:color))

int sharpen_YUYV (unsigned char *S,int w,int h, int n)
{
YUYV *ptS;
 int *dS = NULL;
 int *ptdS;
 int x,y;
 int Add;
 int mOw = w/2;
 int mode;
  n -= 128;
  n /= 16;
if(n == 0)
	return -1;
ptS = (YUYV*) S;
dS = (int*) malloc (w*h*sizeof(int)); 
ptdS = dS;
memset(dS,0,w*h*sizeof(int));
if ( n > 0) {
n = 8-n; mode = 0;
for(y = 1;y < h-1; y++)  
  {
    for(x = 1;x < mOw -1; x ++){
     Add = y*mOw + x;
    ptdS[y*w+2*x] = ptS[Add-mOw-1].Y1 +ptS[Add-mOw].Y0 +ptS[Add-mOw].Y1
           +ptS[Add+mOw-1].Y1 +ptS[Add+mOw].Y0 +ptS[Add+mOw].Y1
           +ptS[Add-1].Y1+ ptS[Add].Y1 -(ptS[Add].Y0 << 3);
    
    ptdS[y*w+2*x+1] = ptS[Add-mOw].Y0 +ptS[Add-mOw].Y1 +ptS[Add-mOw+1].Y0 
           +ptS[Add+mOw].Y0+ ptS[Add+mOw].Y1 +ptS[Add+mOw+1].Y0
           +ptS[Add].Y0 + ptS[Add+1].Y0 -(ptS[Add].Y1 << 3);
    
    }
  } 
} else {
n += 8;mode = 1;
for(y = 1;y < h-1; y++)  
  {
    for(x = 1;x < mOw -1; x ++){
     Add = y*mOw + x;
    ptdS[y*w+2*x] = (ptS[Add-mOw-1].Y1 +ptS[Add-mOw].Y0 +ptS[Add-mOw].Y1
           +ptS[Add+mOw-1].Y1 +ptS[Add+mOw].Y0 +ptS[Add+mOw].Y1
           +ptS[Add-1].Y1+ ptS[Add].Y1) >> 3 ;
    
    ptdS[y*w+2*x+1] = ( ptS[Add-mOw].Y0 +ptS[Add-mOw].Y1 +ptS[Add-mOw+1].Y0 
           +ptS[Add+mOw].Y0+ ptS[Add+mOw].Y1 +ptS[Add+mOw+1].Y0
           +ptS[Add].Y0 + ptS[Add+1].Y0 ) >> 3;
    
    }
  } 
}
if(n == 0)
	n = 1;
if(mode) {
for( y =h*mOw; y; y--){
	ptS->Y0 = CLIP(ptS->Y0+(*ptdS-ptS->Y0)/n);
	ptdS++;
	ptS->Y1 = CLIP(ptS->Y1+(*ptdS-ptS->Y1)/n);
	ptS++;ptdS++;
}
} else {	
for( y =h*mOw; y; y--){
	ptS->Y0 = CLIP(ptS->Y0-(char) *ptdS/n);
	ptdS++;
	ptS->Y1 = CLIP(ptS->Y1-(char) *ptdS/n);
	ptS++;ptdS++;
}
}
 free(dS);
return 0;
}



//Y -0.125Y'
int resize_bilinear( unsigned char **S,int *wo,int *ho,int w,int h)
{
YUYV *ptS;
YUV *S3 = NULL;
YUV P1,P2,P3,P4;
YUV *ptS3;
//int *dS = NULL;
//int *ptdS;
int x,y;
float xscale,yscale;
float dx, dy;
float rx,ry;
int Add;
int Oh = *ho;
int Ow = *wo;
int mOw;
if( !w || ! h)
	return -1;
	
xscale = (float) Ow/(float) w;
yscale = (float) Oh/(float) h;
S3 = (YUV*) malloc (Ow*Oh*sizeof(YUV));
//dS = (int*) malloc (Ow*Oh*sizeof(int));
ptS3 = S3; 
ptS= (YUYV*) *S;
mOw = Ow/2;
 /* compute the gradient
memset(dS,0,Ow*Oh*sizeof(int));
 
  ptdS = dS;
  for(y = 1;y < Oh-1; y++)  
  {
    for(x = 1;x < mOw -1; x ++){
     Add = y*mOw + x;
    ptdS[y*Ow+2*x] = ptS[Add-mOw-1].Y1 +ptS[Add-mOw].Y0 +ptS[Add-mOw].Y1
           +ptS[Add+mOw-1].Y1 +ptS[Add+mOw].Y0 +ptS[Add+mOw].Y1
           +ptS[Add-1].Y1+ ptS[Add].Y1 -(ptS[Add].Y0 << 3);
    
    ptdS[y*Ow+2*x+1] = ptS[Add-mOw].Y0 +ptS[Add-mOw].Y1 +ptS[Add-mOw+1].Y0 
           +ptS[Add+mOw].Y0+ ptS[Add+mOw].Y1 +ptS[Add+mOw+1].Y0
           +ptS[Add].Y0 + ptS[Add+1].Y0 -(ptS[Add].Y1 << 3);
    
    }
  } 
  ptdS = dS;
  */ 
  ptS= (YUYV*) *S;
/*expand the subsampled area to a 444 surface apply the gradient*/ 
for(y=mOw*Oh; y; y--){
	//ptS3->Y0 = CLIP(ptS->Y0-(char)*ptdS/8);
	ptS3->Y0 = ptS->Y0;	
	ptS3->U0 = ptS->U0;
	ptS3->V0 = ptS->V0;
	ptS3++;
	// ptdS++;
	//ptS3->Y0 = CLIP(ptS->Y1-(char)*ptdS/8);
	ptS3->Y0 = ptS->Y1;
	ptS3->U0 = ptS->U0;
	ptS3->V0 = ptS->V0;
	ptS3++; ptS++;
	// ptdS++;
}
/* realloc the output buffer */
*S = (unsigned char*)realloc(*S,w*h*2);
ptS = (YUYV*)*S;
  for(y = 0;y < h; y++)  
  {
    for(x = 0;x < w; x++)
    {
    rx = x * xscale;
    ry = y * yscale;
    dx = rx - ((float)((int)rx));
    dy = ry - ((float)((int)ry));
    Add = ((int)ry)*Ow + (int)rx;
    P1 = S3[Add];
    P2 = S3[Add+1];
    P3 = S3[Add+Ow];
    P4 = S3[Add+Ow+1];
    if(x & 0x01){
     /* impair */
     ptS->Y1 = (unsigned char)((P1.Y0*(1.0-dx)+ P2.Y0*dx)*(1.0-dy)+ (P3.Y0*(1-dx)+ P4.Y0*dx)*dy);
     ptS->V0 = (unsigned char)(((P1.V0-128)*(1.0-dx)+ (P2.V0-128)*dx)*(1.0-dy)+ ((P3.V0-128)*(1.0-dx)+ (P4.V0-128)*dx)*dy +128);
     ptS++;
    } else {
    /* pair */
     ptS->Y0 = (unsigned char)((P1.Y0*(1.0-dx)+ P2.Y0*dx)*(1.0-dy)+ (P3.Y0*(1.0-dx)+ P4.Y0*dx)*dy);
     ptS->U0 = (unsigned char)(((P1.U0-128)*(1.0-dx)+ (P2.U0-128)*dx)*(1.0-dy)+ ((P3.U0-128)*(1.0-dx)+ (P4.U0-128)*dx)*dy +128);
    
    }
    }
  }
  // free(dS);
  free(S3);
  *wo = w;
  *ho = h;
  return 0;
}

int kill_filters (void)
{
printf("kill filters entering \n");
	if (filters->S != NULL){
		printf("free filters->S \n");
		free(filters->S);
		filters->S = NULL;
		}
	
	if (filters != NULL) {
		printf("free filters \n");
		free(filters);
		filters = NULL;
		}
printf("kill filters quit \n");		
return 0;
}
#if 1
#define mean(pm,pi,m) ((((pm)*(m-1))+(pi))/(m))

#define intmean(pm,pi,m) ((((pm) << (m)) -(pm) +(pi)) >> (m))

#define NBMEAN 4

int
reset_YUYV ( YUYV *S,int size)
{
 YUYV pixel;
 YUYV *ptS = S;
 pixel.Y0 = 0;
 pixel.Y1 = 0;
 pixel.U0 = 128;
 pixel.V0 = 128;
 	while (size--) {
 	memcpy( ptS++,&pixel,sizeof(YUYV));
 	}
	return 0;
}
int
minmax_YUYV(unsigned char *S,int w, int h )
{
 int i;
 YUYV *ptS =(YUYV *) S;
 YUYV *ptMin = NULL;
 YUYV *ptMax = NULL;
 YUYV pixmin,pixmax;
 pixmin.Y0 = 255;	 
 pixmax.Y0 = 0;
 ptMin = &filters->pixlow;
 ptMax = &filters->pixhight;
 for (i = w*h/2;i;i--,ptS++){
	 	if(pixmin.Y0 > ptS->Y0) {
			memcpy(&pixmin, ptS, sizeof(YUYV));
			}
		if(pixmax.Y0 < ptS->Y0) {
			memcpy(&pixmax, ptS, sizeof(YUYV));
			}	
	}
	
	ptMin->Y0 =mean(ptMin->Y0,pixmin.Y0,NBMEAN);
	ptMin->U0 =mean(ptMin->U0,pixmin.U0,NBMEAN);
	ptMin->V0 =mean(ptMin->V0,pixmin.V0,NBMEAN);
	
	ptMax->Y0 =mean(ptMax->Y0,pixmax.Y0,NBMEAN);
	ptMax->U0 =mean(ptMax->U0,pixmax.U0,NBMEAN);
	ptMax->V0 =mean(ptMax->V0,pixmax.V0,NBMEAN);
	return ptMax->Y0-ptMin->Y0;;	 
}
int
init_filter(void)
{
	YUYV *ptMin = NULL;
	YUYV *ptMax = NULL;
	if( filters == NULL){
		filters = malloc(sizeof(moy_pict_t));
		filters->isinit = 0;
		filters->w = 0;
		filters->h = 0;
		filters->S = NULL;
	        ptMin = &filters->pixlow;
	        ptMax = &filters->pixhight;
		reset_YUYV(ptMin,1);
		reset_YUYV(ptMax,1);
	}
}
int
filter_YUYV(unsigned char *S,int w, int h, int n, int m, int mode)
{
	YUYV *ptS = (YUYV*) S;
	YUYV *ptM = NULL;
	YUYV *ptMin = NULL;
	YUYV *ptMax = NULL;
	YUYV pixmax,pixmin;
	
	int deltaU,deltaV, deltaY, coefY;
	int orgU,orgV,orgU1,orgV1;
	int i;
	int err = 0;
	if (!mode)
		return -1;
	m = m >> 5;
	// printf("m %d\n",m);
	if (!m) {
	       if(filters->isinit) {
		   filters->w = 0;
		   filters->h = 0;
		   free(filters->S);
		   filters->isinit = 0;
		   filters->S = NULL;
		   printf("reset init filters moy done \n");
		}
	}
	
	if((mode & MOYENNE) && ( m > 0)){
	 if ((filters->S == NULL) || (filters->w != w ||filters->h != h)){
	 	filters->w = w;
		filters->h = h;
		filters->S = (YUYV*)realloc(filters->S,(size_t) (w*h/2) *sizeof(YUYV));
		reset_YUYV(filters->S,(w*h/2));
		filters->isinit = 1;
		printf("init filters moy done \n");	
	 }
	 ptM = filters->S;
	  /* compute the mean filters */
	 for (i = w*h/2;i;i--,ptM++,ptS++){
	 	ptM->Y0 = intmean(ptM->Y0,ptS->Y0, m);
		ptM->U0 = intmean(ptM->U0,ptS->U0, m);
		ptM->Y1 = intmean(ptM->Y1,ptS->Y1, m);
		ptM->V0 = intmean(ptM->V0,ptS->V0, m);
		memcpy(ptS,ptM,sizeof(YUYV));
	 }
	} // end MOYENNE
	
	if(mode & NORMALIZE) {
	    ptMin = &filters->pixlow;
	    ptMax = &filters->pixhight;
	    ptS = (YUYV*) S;
	    deltaY = minmax_YUYV(S,w,h);
	   if(deltaY) {
	    	coefY = (255 << 16)/ deltaY;
		for(i=0; i< 256; i++){
		  filters->UVcomp[i] = ((i*coefY)+128*((1 << 16) -coefY)) >> 16;
	          filters->Ycomp[i] = CLIP((i-ptMin->Y0)*coefY >> 16);
		}
		ptS = (YUYV*) S;
	  for (i = w*h/2;i;i--,ptS++){
	         ptS->U0 = CLIP( filters->UVcomp[ptS->U0]);
	         ptS->V0 = CLIP( filters->UVcomp[ptS->V0]);
	         ptS->Y0 = filters->Ycomp[ptS->Y0];
	         ptS->Y1 = filters->Ycomp[ptS->Y1];	
	  }
	  }
	} //end NORMALIZE
	
	if(mode & WHITEBAL){
	  if (!(mode & NORMALIZE)) {
	  ptMin = &filters->pixlow;
	  ptMax = &filters->pixhight; 	  
	  ptS = (YUYV*) S;
	  deltaY = minmax_YUYV(S,w,h);
	}
	//printf("deltay %d \n",deltaY);
	if(deltaY > 0) {
	   deltaU = ((ptMax->U0-ptMin->U0)<<16) /deltaY;
	   deltaV = ((ptMax->V0-ptMin->V0)<<16) /deltaY;
	   orgU = 128 -( ptMax->U0 - ((deltaU *ptMax->Y0) >> 16)) ;
	   orgV = 128 -( ptMax->V0 - ((deltaV *ptMax->Y0) >> 16)) ;
	   orgU1 = 128 -( ptMin->U0 - ((deltaU *ptMin->Y0) >> 16)) ;
	   orgV1 = 128 -( ptMin->V0 - ((deltaV *ptMin->Y0) >> 16)) ;
	   if((128-(orgU+orgV)/2) >  (128-(orgU1+orgV1)/2)){
	    orgU = orgU1;
	    orgV = orgV1;
	   }
	   for(i= 0 ; i < 256; i++){
	        filters->Ucomp[i] = orgU - ((deltaU*i) >> 16);
	        filters->Vcomp[i] = orgV - ((deltaV*i) >> 16);
	   }	  
	  /* apply the change */
	  ptS = (YUYV*) S;
	  for (i = w*h/2;i;i--,ptS++){
	        ptS->U0 = CLIP( ptS->U0+filters->Ucomp[ptS->Y0]);
	        ptS->V0 = CLIP( ptS->V0+filters->Vcomp[ptS->Y0]);
	  }
	 } // end deltaY
	} // end WHITHE-BALANCE
	
        if(mode & SHARPEN)
	   err = sharpen_YUYV (S,w,h,n);

return err;
}
#endif
#if 0
int
filter_YUYV(unsigned char *S,int w, int h, int n, int m, int mode)
{
	YUYV *ptS = (YUYV*) S;
	YUYV *ptM = NULL;
	YUYV *ptMin = NULL;
	YUYV * ptMax = NULL;
	int deltaU,deltaV, deltaY, coefY;
	int orgU,orgV;
	int i;
	int err = 0;
	if (!mode)
		return -1;
	if( filters == NULL){
		filters = malloc(sizeof(moy_pict_t));
		filters->isinit = 0;
		filters->w = 0;
		filters->h = 0;
		filters->S = NULL;
		ptM = filters->S;
	        ptMin = &filters->pixlow;
	        ptMax = &filters->pixhight;
	}
	m = m >> 4;
	// printf("m %d\n",m);
	if (!m) {
	       if(filters->isinit) {
		   filters->w = 0;
		   filters->h = 0;
		   free(filters->S);
		   filters->isinit = 0;
		   filters->S = NULL;
		   printf("reset init filters moy done \n");
		}
	}
	if((mode & MOYENNE) && ( m > 0)){
	 if ((filters->S == NULL) || (filters->w != w ||filters->h != h)){
	 	filters->w = w;
		filters->h = h;
		filters->S = (YUYV*)realloc(filters->S,(size_t) (w*h/2) *sizeof(YUYV));
		memset(filters->S,0,(w*h/2) *sizeof(YUYV));
		filters->isinit = 1;
		printf("init filters moy done \n");	
	 }
	 ptM = filters->S;
	  /* compute the mean filters */
	 for (i = w*h/2;i;i--,ptM++,ptS++){
	 	ptM->Y0 -= ((ptM->Y0 -ptS->Y0)>> m);
		ptM->U0 -= ((ptM->U0 -ptS->U0)>> m);
		ptM->Y1 -= ((ptM->Y1 -ptS->Y1)>> m);
		ptM->V0 -= ((ptM->V0 -ptS->V0)>> m);
		memcpy(ptS,ptM,sizeof(YUYV));
	 }
	} // end MOYENNE
	if(mode & WHITEBAL){
	ptMin = &filters->pixlow;
	ptMax = &filters->pixhight;
	  ptMin->Y0 = 255;
	  ptMin->Y1 = 255;
	  ptMax->Y0 = 0;
	  ptMax->Y1 = 0;
	  ptS = (YUYV*) S;
	 /* reset min max */
	 for (i = w*h/2;i;i--,ptS++){
	 	if((ptMin->Y0+ptMin->Y1)/2 > ptS->Y0) {
			memcpy(ptMin, ptS, sizeof(YUYV));
			}
		if((ptMax->Y0+ptMax->Y1)/2 < ptS->Y0) {
			memcpy(ptMax, ptS, sizeof(YUYV));
			}	
	}
	deltaY =ptMax->Y0-ptMin->Y0;
	//printf("deltay %d \n",deltaY);
	if(deltaY > 0) {
	    deltaU = ((ptMax->U0-ptMin->U0)<<16) /deltaY;
	    deltaV = ((ptMax->V0-ptMin->V0)<<16) /deltaY;
	    coefY = (255 << 16)/ deltaY;
	    	
	    orgU = 128 -( ptMin->U0 - ((deltaU *ptMin->Y0) >> 16)) ;
	    orgV = 128 -( ptMin->V0 - ((deltaV *ptMin->Y0) >> 16)) ;
	   
	       for(i= 0 ; i < 256; i++){
	          filters->Ucomp[i] = orgU - ((deltaU*i) >> 16);
	          filters->Vcomp[i] = orgV - ((deltaV*i) >> 16);
	          filters->Ycomp[i] = CLIP((i-ptMin->Y0)*coefY >> 16);
	       }
	 
	  
	  /* apply the change */
	  ptS = (YUYV*) S;
	  for (i = w*h/2;i;i--,ptS++){
	       ptS->U0 = CLIP( ptS->U0+filters->Ucomp[ptS->Y0]);
	       ptS->V0 = CLIP( ptS->V0+filters->Vcomp[ptS->Y0]);
	       ptS->Y0 = filters->Ycomp[ptS->Y0];
	       ptS->Y1 = filters->Ycomp[ptS->Y1];	
	  }
	 } // end deltaY
	} // end WHITHE-BALANCE
if(mode & SHARPEN)
	err = sharpen_YUYV (S,w,h,n);

return err;
}
#endif
