/****************************************************************************
#	 	GspcaGui:  Gspca/Spca5xx Grabber                            #
# 		Copyright (C) 2004 2005 2006 Michel Xhaard                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/ 
enum {
	NOROT = 0,
	ROT90,
	ROT180,
	ROT270,
	FLIPX,
	FLIPY,
};

#define SHARPEN 1
#define MOYENNE 2
#define WHITEBAL 4
#define NORMALIZE 8
#define GAMMACORRECT 16

typedef struct YUYV {
	unsigned char Y0;
	unsigned char U0;
	unsigned char Y1;
	unsigned char V0;
} YUYV;

typedef struct YUV {
	unsigned char Y0;
	unsigned char U0;
	unsigned char V0;
} YUV;

typedef int (*functrot) (unsigned char *S , int *width, int *height);
int rot90 (unsigned char *S , int *width, int *height);
int rot180 (unsigned char *S , int *width, int *height);
int rot270 (unsigned char *S , int *width, int *height);
int flipy (unsigned char *S , int *width, int *height);
int flipx (unsigned char *S , int *width, int *height);
int dummyrot (unsigned char *S , int *width, int *height);
int resize_bilinear( unsigned char **S,int *wo,int *ho,int w,int h);
int sharpen_YUYV (unsigned char *S,int w,int h, int n);
int filter_YUYV(unsigned char *S,int w, int h, int n,int m, int mode);
int kill_filters (void);
