/****************************************************************************
#	 	GspcaGui:  Gspca/Spca5xx Grabber                            #
# 		Copyright (C) 2004 2005 2006 Michel Xhaard                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/ 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <wait.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <errno.h>
#include <pwd.h>
#include <signal.h>

#include "colors/color.h"
#include "gui.h"
#include "msgipc.h"
#include "display.h"
#include "converter/cvrt.h"
#include "decoder/decoder.h"
#include "osd/font.h"
#include "picture/picture.h"



#define orange 0xfd951800
#define jaune 0xffec2600
#define rouge 0xff542c00
#define bleue 0x3d6cbe00

int debug = 0;
int pid;
int flags = IPC_NOWAIT;
int mid; // messages Queue id
pid_t mypid;
int videoOk=1;
struct passwd *mypasswd;

videoIn_t *videoIn = NULL;
void grabber (void);
void sigchld_handler(int s);
void processvideo (const char *video);

int
main (int argc, char *argv[])
{
int i;
const char *videodevice = NULL;
for (i = 1; i < argc; i++) {
		/* skip bad arguments */
		if (argv[i] == NULL || *argv[i] == 0 || *argv[i] != '-') {
			continue;
		}
		if (strcmp (argv[i], "-d") == 0) {
			if (i + 1 >= argc) {
				printf ("No parameter specified with -d, aborting.\n");
				exit (1);
			}
			videodevice = strdup (argv[i + 1]);
		}
}
   mypasswd = getpwuid(getuid());
   //printf(" home ->  %s\n",mypasswd->pw_dir);
   if(( mid = messcreate()) < 0){
   perror("create message fifo");
    exit(1);
    }
   initLut();
  /* Fork and IPC message create  */
  if ((pid = fork ()) < 0)
    exit (-1);

  if (pid == 0)
    {
      /* We are in child */
      processvideo (videodevice);
      exit (1);
    }
  else
    {
      /* We are in parent */
      telecom ();
    }

  /* Wait for exit status */
  waitpid (pid, NULL, 0);
  freeLut();
    /* Destroy the Fifo */
  if(messdestroy(mid) < 0)
  	perror("destroy fifo failed");
  exit (1);

}
paltopal getconverter(int format)
{
switch (format){
 case VIDEO_PALETTE_JPEG:
   return mjpgtoPyuv422;
 break;
 case VIDEO_PALETTE_YUV420P:
   return yuv420PtoPyuv422;
 break;
 case VIDEO_PALETTE_RGB24:
   return rgb24toPyuv422;
 break;
 case VIDEO_PALETTE_RGB565:
   return rgb565toPyuv422;
 break;
 case VIDEO_PALETTE_RGB32:
   return rgb32toPyuv422;
 break;
 }
 return NULL;
}

int getframe(unsigned char **buff,int *w,int *h, int *frame,videoIn_t *vd)
{
 paltopal convert = NULL;;
if (debug ) printf("enter getframe\n");
 convert = getconverter(vd->formatIn);
 if(!convert)
 	return -1;	
if(debug) printf("get converter\n");	
 while ((*frame == vd->framecour) && vd->signalquit) usleep(1000);
       if (vd->signalquit){
	vd->framebuffer[*frame].readlck++;
	if(debug) printf("buffersize %d width %d height %d\n",vd->framebuffer[*frame].size,vd->framebuffer[*frame].w,
		vd->framebuffer[*frame].h);
		if((*w != vd->framebuffer[*frame].w) || (*h != vd->framebuffer[*frame].h)){
		*w =vd->framebuffer[*frame].w;
		*h = vd->framebuffer[*frame].h;
		*buff = (unsigned char *) realloc(*buff, (size_t) (*w) * (*h +8) * 2);
		}
	convert(vd->framebuffer[*frame].data,*buff,*w,*h);		
	vd->framebuffer[*frame].readlck--;
	*frame = (*frame+1)% NBUFFER;
	}
return 0;
}
int push_frame(unsigned char **buff,unsigned char *S,int w, int h)
{
	*buff = (unsigned char*) realloc( *buff , (size_t)w*h*2);
	memcpy(*buff,S,w*h*2);
	return (w*h*2);
}

int pop_frame(unsigned char *src, unsigned char *dst, int size)
{
     memcpy(dst,src,size);
 	return size;
}
struct video_screen *intro(const char *video)
{
	struct video_screen *screen = NULL;
	struct request req;
   	struct answer callback;
	SDL_Event sdlevent;
	unsigned char buf[2];
	unsigned char *p = NULL;
	int i  = 10;
	int toglemode = 0;
	init_sdlall();
	screen = init_display();
  	SDL_WM_SetCaption ("Spcagui V2 Windows ", "Winvid");
  	SDL_ShowCursor (1);
	p = (unsigned char *) screen->overlay->pixels[0];
 SDL_DisplayYUVOverlay(screen->overlay, &screen->drect);
 /* pix now contain the default screen display */
  screen->mode = NOTHING;
  while(!screen->mode)
	{
	i++;
     	if (i > (screen->height - 150)) i =10;
	SDL_LockYUVOverlay(screen->overlay);
	memcpy(p,screen->intro_image.pix,screen->intro_image.w*screen->intro_image.h*2);
	
	 if (!(i%8)) toglemode = !toglemode;
	 if(toglemode){
	   printscreenOverlay(p,160,65,24,"If you like it " ,screen->intro_image.w,screen->intro_image.h,bleue,0);
	   printscreenOverlay(p,100,150,24,"Consider a DONATION !!" ,screen->intro_image.w,screen->intro_image.h,bleue,0);
	 //  printscreenOverlay(p,100,450,24,"(C)2006 Michel Xhaard " ,screen->intro_image.w,screen->intro_image.h,bleue,0);
	   }	 
	  printscreenOverlay(p,160,i,16,"Get your SpcaGUI mode:" ,screen->intro_image.w,screen->intro_image.h,orange,0);
	  printscreenOverlay(p,210,i+30,16," G) V4L Grabber " ,screen->intro_image.w,screen->intro_image.h,rouge,0);
	  printscreenOverlay(p,210,i+60,16," P) AVI Player" ,screen->intro_image.w,screen->intro_image.h,rouge,0);
	  printscreenOverlay(p,210,i+90,16," C) TCP Client" ,screen->intro_image.w,screen->intro_image.h,rouge,0);
	  printscreenOverlay(p,160,i+120,16,"From the Remote Control" ,screen->width,screen->height,orange,0);
	SDL_UnlockYUVOverlay(screen->overlay);
	SDL_DisplayYUVOverlay(screen->overlay, &screen->drect);
/* initialize the Message queue get the remote pid for the answer */
	if(getRequest(mid,&req,flags))
	 {
	buf[0] = req.act;
	buf[1] = req.val;
	callback.type=req.my_pid;
	mypid = req.my_pid;
	snprintf(callback.mess,12,"%s","");
	printf (" Get message id %d, value %d \n", buf[0],buf[1]);
	switch (buf[0])
	    {case QUIT:
	    screen->mode = QUIT;   	    
	    break;
	    case PLAYER:
	    if (buf[1])
		snprintf(callback.mess,12,"%s","PLAYER"); 
		if(sendMessagebyId(mid,PLAYER,&callback,flags) < 0)
	   	printf ("error sending callback \n"); 
		screen->mode = PLAYER;
	    break;
	    case GRABBER:
	    if (buf[1])
		snprintf(callback.mess,12,"%s",video);
		if(sendMessagebyId(mid,GRABBER,&callback,flags) < 0)
	   	printf ("error sending callback \n");
		screen->mode = GRABBER;   
	    break;
	    case CLIENT:
	    if (buf[1])
		snprintf(callback.mess,12,"%s","192.168.0.1");
		if(sendMessagebyId(mid,CLIENT,&callback,flags) < 0)
	   	printf ("error sending callback \n");
		screen->mode = CLIENT;   
	    break;
	    }
	  } 
	
	usleep(100000); // sleep 100ms    
	}
	SDL_LockYUVOverlay(screen->overlay);
	memcpy(p,screen->intro_image.pix,screen->intro_image.w*screen->intro_image.h*2);
 	printscreenOverlay(p,50,150,24,"Wait Probing the hardware" ,screen->intro_image.w,screen->intro_image.h,rouge,0);
	printscreenOverlay(p,150,200,24,"Can take times !!" ,screen->intro_image.w,screen->intro_image.h,rouge,0);
	SDL_UnlockYUVOverlay(screen->overlay);
	SDL_DisplayYUVOverlay(screen->overlay, &screen->drect);
	usleep(100000);
return screen;	
}

int
processgrab(struct video_screen *screen,const char *video)
{
 unsigned char buf[2];
   struct request req;
   struct answer callback;
   SDL_Event sdlevent;
   unsigned char *cpix = NULL;
   unsigned char *spix = NULL;
   int ssize = 0;
   functrot filtrot=dummyrot;
   const char videodevice[] = "/dev/video0";
   const char *videochan;
    int frameread = 0;
 int frame = 0;
 pthread_t w1;
 pthread_t p1;
 pthread_t r1;
  int err;
 struct sigaction sa;
 record_data_t recdata;
 int curmode = screen->mode;
 int run = 1; 
 int len;
 int z = NOZOOM;
  int change = 0;
  int pause = 0;
  int mavi = 0;
  int fliprgb = 0;
  int photo = 0;
  int i = 0;
int width,height;
int filtermode = 0;
int sharpness = 128;
int denoise = 0;
if(video == NULL)
	videochan = videodevice;
	else
	videochan = video;
callback.type=mypid; // actualise who is the sender for answer
 width = screen->screen->w ;
  height = screen->screen->h;
  int size = width * height *2;
  cpix = malloc(size); 
 videoIn = openvideo(videochan); 
 if(!videoIn) 
 	goto the_end;
  streamstop(videoIn);
  recdata.vd = videoIn;
  recdata.record_ON = 0;
  
    if((err= pthread_create (&w1, NULL, (void *) grabber, NULL)) != 0){
	printf("thread grabbing error %d \n",err);
	 closevideo(videoIn);
	 run = 0;
	goto the_end;
 }
 if((err= pthread_create (&p1, NULL, (void *) waitandshoot,(void *) screen)) != 0){
	printf("thread picture error %d \n",err);
	 closevideo(videoIn);
	pthread_cancel(w1);
	run = 0;
	goto the_end;
 }
 	sa.sa_handler = sigchld_handler;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = SA_RESTART;
	init_filter();
	videoIn->signalquit=1;
	streamstart (videoIn);
	printf("report probe result to the remote control grabbing !!\n");
		callback.val = videoIn->palette;
		if(sendMessagebyId(mid,PALETTE,&callback,flags) < 0)
	   	    printf ("error sending callback \n");	
		callback.val = videoIn->curpalette;
		if(sendMessagebyId(mid,PALETTE,&callback,flags) < 0)
	   	    printf ("error sending callback \n");	
		callback.val = videoIn->sizenative[paletteMIconvert(videoIn->curpalette)];
		if(sendMessagebyId(mid,SIZE,&callback,flags) < 0)
	   	    printf ("error sending callback \n");	
		callback.val = videoIn->cursize;
		if(sendMessagebyId(mid,SIZE,&callback,flags) < 0)
	   	    printf ("error sending callback \n");
		callback.val = videoIn->fsgctrl(videoIn,GBRIGHTNESS,0);
		if(sendMessagebyId(mid,BRIGHT,&callback,flags) < 0)
		    printf ("error sending callback \n");
		callback.val = videoIn->fsgctrl(videoIn,GCONTRAST,0);
		if(sendMessagebyId(mid,CONTRAST,&callback,flags) < 0)
	   	    printf ("error sending callback \n");
		callback.val = videoIn->fsgctrl(videoIn,GCOLORS,0);
		if(sendMessagebyId(mid,COLOR,&callback,flags) < 0)
		     printf ("error sending callback \n");	
  while (videoIn->signalquit && screen->mode == curmode)
    {
    if(!pause){
        getframe(&cpix,&width,&height, &frame,videoIn);
        ssize = push_frame(&spix,cpix,width, height);
       } else {
       pop_frame(spix,cpix,ssize);
       usleep(100000);
       }
    //sharpen_YUYV (cpix,width,height, sharpness);
    filter_YUYV(cpix,width,height, sharpness,denoise, filtermode);  
    process_display(cpix, width, height,z,filtrot, screen);
    SDL_DisplayYUVOverlay(screen->overlay, &screen->drect);
 if(getRequest(mid,&req,flags))
	{
	buf[0] = req.act;
	buf[1] = req.val;
	callback.type=req.my_pid;
	snprintf(callback.mess,12,"%s","");
	printf (" Get message id %d, value %d \n", buf[0],buf[1]);
	switch (buf[0]) {
	    case QUIT:
	    videoIn->signalquit = 0;
	    run = 0; //quit all
	    break;
	    case SIZE:
	    	z= NOZOOM;
		filtrot = dummyrot;
	      streamstop(videoIn);
	        printf("input change size \n",buf[1]);
	      changeSize (videoIn,buf[1] );
	      streamstart (videoIn);
	    break;
	    case PALETTE:
	    	z= NOZOOM;
		filtrot = dummyrot;
	      streamstop(videoIn);
	        printf("input change size \n",buf[1]);
	        setPalette (videoIn,buf[1]);
		callback.val = videoIn->sizenative[paletteMIconvert(videoIn->curpalette)];
		if(sendMessagebyId(mid,SIZE,&callback,flags) < 0)
	   	    printf ("error sending callback \n");	
		callback.val = videoIn->cursize;
		if(sendMessagebyId(mid,SIZE,&callback,flags) < 0)
	   	    printf ("error sending callback \n");	
	      streamstart (videoIn);
	    break;
	    case ROTATE:
	    	switch (buf[1]){
		case 0:
		if(z == NOZOOM)
		   filtrot = dummyrot;
		break;
		case 1:
		if(z == NOZOOM)
	           filtrot = rot90;
		break;
		case 2:
		if(z == NOZOOM)
		   filtrot= rot180;
		break;
		case 4:
		if(z == NOZOOM)
	           filtrot = rot270;
		break;
		case 128:
		if(z == ZOOMON)
			z = NOZOOM;
		if(z == DRAWRECT)
	       		z= ZOOMON;
		break;
		}
	    break;
	    case PAUSE:
	         pause = buf[1];	 
	    break;
	    case PHOTO:
	    printf("get photo %d\n",buf[1]);
	    	screen->pictflag = buf[1];
	    break;
	    case AVI:
	    	recdata.record_ON = buf[1];
		if(recdata.record_ON){
		if((err= pthread_create (&r1, NULL, (void *)recordavi,(void *) &recdata)) != 0){
	                 printf("thread avi error %d \n",err);
                 }
		}
	    break;
	    case COLOR:
	    	videoIn->fsgctrl(videoIn,SCOLORS,buf[1]);
	    break;
	    case CONTRAST:
	    	videoIn->fsgctrl(videoIn,SCONTRAST,buf[1]);
	    break;
	    case BRIGHT:
	    	videoIn->fsgctrl(videoIn,SBRIGHTNESS,buf[1]);
	    break;
	    case FRMRATE:
	    	if(buf[1]== 1)
	    	videoIn->fsgctrl(videoIn,DWDTIMES,0);
		else if(buf[1] == 2)
		videoIn->fsgctrl(videoIn,UPDTIMES,0);
	    break;
	    case QUALITY:
	    	if(buf[1]== 1)
	    	videoIn->fsgctrl(videoIn,UPQUAl,0);
		else if(buf[1] == 2)
		videoIn->fsgctrl(videoIn,DWQUAL,0);
	    break;
	    case AUTO:
	    	switch (buf[1]){
		case 0:
		videoIn->fsgctrl(videoIn,AUTOONOFF,0);
		filtermode &= ~(WHITEBAL | NORMALIZE);
		break;
	    	case 1:
	    	videoIn->fsgctrl(videoIn,AUTOONOFF,1);
		filtermode &= ~(WHITEBAL | NORMALIZE);
		break;
		case 2:
		videoIn->fsgctrl(videoIn,AUTOONOFF,0);
		filtermode |= (WHITEBAL|NORMALIZE);
		break;
		case 3:
		videoIn->fsgctrl(videoIn,AUTOONOFF,1);
		filtermode |= (WHITEBAL|NORMALIZE);
		break;
		}
	    break;
	    case SHARP:
	    	sharpness = buf[1];
		if((sharpness-128)/16)
		          filtermode |= SHARPEN;
			  else
			  filtermode &= ~SHARPEN;
		printf("Sharness %d mode %d\n", sharpness,filtermode);
	    break;
	    case DENOISE:
	    denoise = buf[1];
	    		if(denoise >> 4)
				filtermode |= MOYENNE;
			else 
				filtermode &= ~MOYENNE;
		printf("denoise %d mode %d\n", denoise,filtermode);	
	    break;
	    case PLAYER:
	    if (buf[1]){
		snprintf(callback.mess,12,"%s","PLAYER");   
		if(sendMessagebyId(mid,PLAYER,&callback,flags) < 0)
	   	printf ("error sending callback \n"); 
		}
		if(curmode == PLAYER)
		screen->mode = NOTHING; //PLAYER OFF
		else
		screen->mode = PLAYER; //NEXT need PLAYER MODE
		 printf("callback msg %s curmode %d mode %d \n",
		        callback.mess,curmode,screen->mode);
		videoIn->signalquit = 0; //need to quit to restart the new mode
	    break;
	    case GRABBER:
	    if (buf[1]){
		snprintf(callback.mess,12,"%s","dev/video0");
		if(sendMessagebyId(mid,GRABBER,&callback,flags) < 0)
	   	printf ("error sending callback \n");
		}
		if(curmode == GRABBER)
		screen->mode = NOTHING;
		else
		screen->mode = GRABBER;
		 printf("callback msg %s curmode %d mode %d \n",
		        callback.mess,curmode,screen->mode);
			videoIn->signalquit = 0;
	    break;
	    case CLIENT:
	    if (buf[1]){
		snprintf(callback.mess,12,"%s","192.168.0.1");
		if(sendMessagebyId(mid,CLIENT,&callback,flags) < 0)
	   	printf ("error sending callback \n");
		}
		if (curmode == CLIENT)
		screen->mode = NOTHING;
		else
		screen->mode = CLIENT; 
		printf("callback msg %s curmode %d mode %d \n",
		        callback.mess,curmode,screen->mode);
			videoIn->signalquit = 0;
	    break;
	    }    
	}
	while (SDL_PollEvent(&sdlevent)) {	//scan the event queue
	int x,y;
	    switch (sdlevent.type) {
	    case SDL_KEYDOWN:
	      switch (sdlevent.key.keysym.sym) {
	        case SDLK_UP:
		if(z == NOZOOM)
		   filtrot = dummyrot;
	        break;
	        case SDLK_DOWN:
		if(z == NOZOOM)
		   filtrot= rot180;
	        break;
	       case SDLK_RIGHT:
	       if(z == NOZOOM)
	           filtrot = rot90;
	       break;
	       case SDLK_LEFT:
	       if(z == NOZOOM)
	           filtrot = rot270;
	       break;
	       case SDLK_SPACE:
	       if(z == DRAWRECT)
	       		z= ZOOMON;
	       break;
	       case SDLK_n:
	       if(z == ZOOMON)
	               z = NOZOOM;
	       break;
	    }
	    break;
	    case SDL_MOUSEBUTTONDOWN:
	    
	    if( z == NOZOOM){
	      SDL_GetMouseState(&screen->rectangle.x0, &screen->rectangle.y0);
	      screen->rectangle.x1 = screen->rectangle.x0;
	      screen->rectangle.y1 = screen->rectangle.y0;
	    z = GETRECT;
	    } else
	       z = NOZOOM;
	    break;
	    case SDL_MOUSEBUTTONUP:
	    if (z == GETRECT) {
	    	SDL_GetMouseState(&screen->rectangle.x1, &screen->rectangle.y1);
	    z = DRAWRECT ;   
	    }
	    break;
	    case SDL_MOUSEMOTION:
	    if(z == GETRECT) {
		SDL_GetMouseState(&screen->rectangle.x1, &screen->rectangle.y1);
	    }
	    break;
	    case SDL_VIDEORESIZE:
		resize_display(screen,sdlevent.resize.w,
				     sdlevent.resize.h);
	    break;
	    }
         } //poll even
    }
  
  streamstop(videoIn);
  pthread_join (w1, NULL);
  pthread_cancel(p1);
  pthread_join (p1,NULL);
  printf("thread grab picture quit \n");
  kill_filters();
  printf("kill filters done\n");
  closevideo(videoIn); 
  printf("closevideo done\n");
  sleep (1);
the_end:
  free(cpix);
  if (spix){
  	free(spix);
	spix = NULL;
	}
printf("grabber mode quit \n");
return run;
}

void
processvideo (const char *video)
{
struct video_screen *screen = NULL; 
 int run = 1; 

while(run) {
      screen = intro(video);
     switch (screen->mode){
	case QUIT:
	     run = 0;
	break;
	case GRABBER:
	     run = processgrab(screen,video);
	break;
	case PLAYER:
		printf("Player Not yet implemented sorry\n");
	     run = 0;
	break;
	case CLIENT:
		printf("Client Not yet implemented sorry\n");
	     run = 0;
	break;
	default:
	     run = 0;
	break;
      }
      free_display(screen);
}  
SDL_Quit ();
}

void
grabber (void)
{
int err = 0;
  for (;;)
    {
      err = grabone(videoIn);
      if (!videoIn->signalquit || (err < 0)){
          printf("GRABBER going out !!!!! \n");
	  break;
	}
    }
}
void sigchld_handler(int s)
{
	videoIn->signalquit = 0;
}
