/****************************************************************************
#	 	GspcaGui:  Gspca/Spca5xx Grabber                            #
# 		Copyright (C) 2004 2005 2006 Michel Xhaard                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/   
#ifndef TELECOMI_H
#define TELECOMI_H
#include <SDL/SDL.h>
#include "gui.h"

#define HOTSURFACE 48
#define NBX 5
#define NBY 10 
// 9

#define TELECOM_X HOTSURFACE*NBX
#define TELECOM_Y HOTSURFACE*NBY

extern int bpp ;


typedef void (*control)(int ,void *wcontrol,SDL_Surface *, unsigned char*);

typedef struct key_action_t {
    SDLKey key;
    action_gui action;
} key_action_t;
#if 0
key_action_t keyaction[] = {
    {SDLK_n,NOTHING},
    {SDLK_b,PHOTO},
    {SDLK_x,AVI},
    {SDLK_w,PAUSE},
    {SDLK_w,GRAB},
    {SDLK_c,QUIT},
    {SDLK_v,FLIPRGB},
    {SDLK_z,BRIGHT},
    {SDLK_a,CONTRAST},
    {SDLK_r,COLOR},
    {SDLK_e,SIZE},
    {SDLK_y,PALETTE},
    {SDLK_t,SOUND},
    {SDLK_s,ROTATE},
    {SDLK_p,DENOISE},
    {SDLK_l,SHARP},
    {SDLK_q,FRMRATE},
    {SDLK_m,QUALITY},
    {SDLK_x,END_CONTROL}
};
#endif
struct button {
	int id;
	int x;
	int y;
	int toggle;
	SDL_Surface *iconrelease;
	SDL_Surface *iconpress;
};

struct potentiometre {
	int id;
	char label[12];
	int x;
	int y;
	int value;
	int y0;
	SDL_Surface *fond;
	SDL_Surface *curseur;
};

struct control {
	int id;
	char label[8][5];
	int x;
	int y;
	int offset;
	int nbpuce;
	int incpuce;
	int available;
	int valid;
	int courant;
	SDL_Surface *fond;
	SDL_Surface *pucevalid;
	SDL_Surface *puceactive;
	SDL_Surface *pucevide;
};

struct pad {
	int id;
	int x;
	int y;
	int state;
	SDL_Surface *fond;
	SDL_Surface *padup;
	SDL_Surface *paddown;
	SDL_Surface *padright;
	SDL_Surface *padleft;
	SDL_Surface *padcenter;
};

struct toglesw {
	int id;
	int x;
	int y;
	int mode;
	int valup;
	int valdown;
	SDL_Surface *fond;
	SDL_Surface *togleup;
	SDL_Surface *togledown;
	SDL_Surface *togleall;
};

struct ecran {
	int id;
	int x;
	int y;
	int length;
	char *stinfo;
	SDL_Surface *fond;
	SDL_Surface *orig;
};
void
init_info(int id,int x, int y, struct ecran *myecran);
void
draw_info (struct ecran *myecran,SDL_Surface *Screen);
void
process_info( char *chaine ,struct ecran *myecran,SDL_Surface *Screen);
void
free_info(struct ecran *myecran);

void init_togle( int id, int value,int x,int y,
		struct toglesw *mytogle );
void free_togle( struct toglesw *mytogle );
void 
draw_togle (struct toglesw *mytogle,SDL_Surface *Screen);
void 
process_togle (int y ,struct toglesw *mytogle,
		SDL_Surface *Screen, unsigned char *message);
		
		
void init_pad( int id, int value,int x,int y,
		struct pad *mypad );
void free_pad( struct pad *mypad );
void 
draw_pad (struct pad *mypad,SDL_Surface *Screen);
void 
process_pad (int valx,int valy ,struct pad *mypad,
		SDL_Surface *Screen, unsigned char *message);
		
/* button if value is set to 1 oneshoot button otherwhise toggle */
void 
init_button ( int id, int value,int x,int y,
		struct button *mybutt );
void 
free_button ( struct button *mybutt);
void 
draw_button ( struct button *mybutt,SDL_Surface *Screen);
void 
process_button (int value ,struct button *mybutt,
		SDL_Surface *Screen, unsigned char *message);
void
refresh_button (int id, int value, struct button *mybutt, SDL_Surface * Screen);

/* value is between 0 to 255 */		
void 
init_potentiometre ( int id ,int value,int x,int y,
		struct potentiometre *mypot );	
void 
free_potentiometre (struct potentiometre *mypot);
void 
draw_potentiometre(struct potentiometre *mypot, SDL_Surface *Screen);
void 
process_potentiometre(int yp, struct potentiometre *mypot, 
		SDL_Surface *Screen, unsigned char *message);
void
refresh_potentiometre (int id, int value,struct potentiometre *mypot , SDL_Surface * Screen );
/* control box nb is number of puce maximum is 8
	value is available with 2^ if active red available green not available grey */		
void 
init_control (int id,int value,int nb, int x, int y,
		 struct control *mycontrol); 
void
free_control (struct control *mycontrol);
void 
draw_control (struct control *mycontrol,SDL_Surface *Screen);
void 
process_control (int yp,struct control *mycontrol,
		SDL_Surface *Screen,unsigned char *message);
#if 0
void 
refresh_control( int value, struct control *mycontrol,
		SDL_Surface *Screen,unsigned char *message);
#endif

void
refresh_control (int value, int masq, struct control *mycontrol, SDL_Surface * Screen);

action_gui
witchButton (int x, int y);

action_gui
witchKey (SDLKey key);

#endif	
