/****************************************************************************
#	 	font : Sdl printscreen Animation   lepetitatelier .         #
#.                                                                          #
# 		Copyright (C) 2003 2004 2005 2006 Michel Xhaard             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/

#include "font.h"
#include "../colors/color.h"
 
/*********************************************************************************/

struct rgbfont {
	unsigned char blue;
	unsigned char green;
	unsigned char red;
};

#define ADDRESSE(x,y,w) (((y)*(w))+(x))

unsigned char *YUYVbutt = NULL;

typedef struct YU {
    unsigned char Y0;
    unsigned char U0;
} YU;

/* Each pixels in the resulting figure need to be set. For each one take the nearest available in the original surface
If the last Chroma component is U take a V else take U by moving the index in the nearest pixel from the left 
This routine only deal with X axis you need to make the original picture with the good height */

static int resize(unsigned char *INbuff, unsigned char *OUTbuff,
		  int Owidth, int Oheight, int width, int height)
{
    int rx, ry;
    int xscale,yscale;
    int x, y;
    int Cc, lastCc;
    YU *input = (YU *) INbuff;
    YU *output = (YU *) OUTbuff;
    if (!width || !height)
	return -1;
    /* at start Cc mean a U component so LastCc should be a V */
    lastCc = 1;
    xscale = (Owidth << 16) / width;
    yscale =(Oheight << 16) / height;
    
    for (y = 0; y < height; y++) {
	for (x = 0; x < width; x++) {
	    rx = x * xscale >> 16;
	    ry = y * yscale >> 16;
	    if (((2 * rx + 1) & 0x03) == 3)
		Cc = 1;		// find V component
	    else
		Cc = 0;
	    if (lastCc == Cc) {
		/* no Chroma interleave correct by moving the index */
		rx -= 1;
		Cc = !Cc;
	    }
	    memcpy(output++, &input[ADDRESSE((int) rx, (int) ry, Owidth)],
		   sizeof(YU));
	    lastCc = Cc;
	}
    }
    return 0;
}
void printcharOverlay (unsigned char *so, int x, int y, int h, unsigned char c,int width, int colors,int background)
{
	int j,k;
	unsigned char masq = 0x80;
	YU *ptout = (YU *) so;
	int l = h;
	int rx,ry;
	int xscale,yscale;
	char Car[64];
	YU pixel;
	struct rgbfont pix;
		        //ping //cyan
	unsigned char u; // = 200; // 128;//152;
	unsigned char v; // = 128; //200;//100;
	unsigned char Y; // = colors;
	pix.red = (colors & 0xff000000) >> 24 ;
	pix.green = (colors & 0x00ff0000) >> 16;
	pix.blue = (colors & 0x0000ff00) >> 8;
	Y = RGB24_TO_Y(pix.red,pix.green,pix.blue);
	u = YB_TO_U(pix.blue,Y);
	v = YR_TO_V(pix.red,Y);
	
	pixel.Y0 = Y;
	xscale = (8 << 16)/l;
	yscale = (8 << 16)/h;
	/* expand the bit to byte array */
	for(j =0; j < 8; j++){
		masq = 0x80;
		for(k=0; k < 8; k++){
		if (masq & fontdata[(c*8)+j])
			Car[j*8+k] =1;
		else
			Car[j*8+k] =0;
		 masq = masq >> 1;
		}
	}
	ptout += ((y*width) +x);
	
	for(j =0; j< h; j++){
		for(k=0; k < l; k++){
		rx = k * xscale >> 16;
		ry = j * yscale >> 16;
		if (Car[(ry*8)+rx]){
		/* ecrire le pixel */
		/* chroma sample */
			if (((x+k)& 0x01)) 
				pixel.U0 = v;
			else
				pixel.U0 = u;
		memcpy(&ptout[k],&pixel,sizeof(YU));
		}
		}
		ptout += width;
	}	
}
void printscreenOverlay ( unsigned char *so,int x, int y,int h, unsigned char *st,int width, int height, int colors, int background)
{
	int i = 0;
	int posx = x;
	int posy = y;
	if ((x+h) > width || (y+h) > height)
		return; 
	if (st == NULL) 
		return;
	while (st[i]){
	if(posx < (width - h)) {
		if (st[i] ==' '){
			posx += h/2;
		} else {
			printcharOverlay(so,posx,posy,h,st[i],width,colors,background);
			posx += h;
		}
		i++;
	} else if (posy < height-h){
		posy += h;
		posx = x;
		}
	}	
}
void printchar (unsigned char *screen, int x,int y,int h, unsigned char c,int width, int colors, int background)
{
	int j,k;
	int rx,ry;
	int xscale,yscale;
	char Car[64];
	struct rgbfont pixel;
	struct rgbfont backpixel;
	unsigned char masq = 0x80;
	int l = h;
	struct rgbfont *ptout =(struct rgbfont *)screen ;
	xscale = (8 << 16)/l;
	yscale = (8 << 16)/h;
	pixel.red = (colors & 0xff000000) >> 24 ;
	pixel.green = (colors & 0x00ff0000) >> 16;
	pixel.blue = (colors & 0x0000ff00) >> 8;
	if(background){
	backpixel.red = (background & 0xff000000) >> 24 ;
	backpixel.green = (background & 0x00ff0000) >> 16;
	backpixel.blue = (background & 0x0000ff00) >> 8;
	}
	/* expand the bit to byte array */
	for(j =0; j < 8; j++){
		masq = 0x80;
		for(k=0; k < 8; k++){
		if (masq & fontdata[(c*8)+j])
			Car[j*8+k] =1;
		else
			Car[j*8+k] =0;
		 masq = masq >> 1;
		}
	}
	ptout += ((y*width) +x);
	for(j =0; j< h; j++){
		for(k=0; k < l; k++){
		rx = k * xscale >> 16;
		ry = j * yscale >> 16;
		if (Car[(ry*8)+rx]){
		/* ecrire le pixel */
		memcpy(&ptout[k],&pixel,sizeof(struct rgbfont));
		} else {
		if (background)
		memcpy(&ptout[k],&backpixel,sizeof(struct rgbfont));
		}
		}
		ptout += width;
	}	
}
void printscreen ( unsigned char *screen,int x, int y,int h, unsigned char *st, int width,int height, int colors, int background )
{
	int i = 0;
	int posx = x;
	int posy = y;
	if ((x+h) > width || (y+h) > height)
		return; 
	if (st == NULL) 
		return;
	while (st[i]){
	if(posx < (width - h)) {
		if (st[i] ==' '){
			posx += h/2;
		} else {
			printchar(screen,posx,posy,h,st[i],width,colors,background);
			posx += h;
		}
		i++;
	} else if (posy < height-h){
		posy += h;
		posx = x;
		}
	}	
}
