/****************************************************************************
#	 	Mire : Sdl printscreen Animation   lepetitatelier .         #
#.                                                                          #
# 		Copyright (C) 2003 2004 2005 Michel Xhaard                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <string.h>
#include <time.h>
#include <SDL/SDL.h>
#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480
#include "font.h"
struct rgb
{
  unsigned char blue;
  unsigned char green;
  unsigned char red;
};

int
main (int argc, char *argv[])
{
  SDL_Surface *pscreen;
  struct rgb *pixels = NULL;
  struct rgb *ppixels = NULL;
  SDL_Event sdlevent;
  char contrast[]="CONTRAST";
  char brightness[]="BRIGHTNESS";
  char colors[]="COLORS";
  int nbline = 0;
  int bpp, i;
  struct rgb triplet;
  int run = 1;
  bpp = 3;
  if (SDL_Init (SDL_INIT_VIDEO) < 0)
    {
      fprintf (stderr, "Couldn't initialize SDL: %s\n", SDL_GetError ());
      exit (1);
    }
  pscreen = SDL_SetVideoMode (SCREEN_WIDTH, SCREEN_HEIGHT, 8 * 3,
 			SDL_DOUBLEBUF | SDL_SWSURFACE);
//			      SDL_DOUBLEBUF | SDL_FULLSCREEN | SDL_SWSURFACE);
  if (pscreen == NULL)
    {
      printf ("Couldn't set %d*%dx%d video mode: %s\n",
	      SCREEN_WIDTH, SCREEN_HEIGHT, bpp * 8, SDL_GetError ());
      exit (1);
    }

  ppixels = (struct rgb *) malloc (SCREEN_HEIGHT * SCREEN_WIDTH * bpp);
  pixels = ppixels;
  nbline = SCREEN_HEIGHT / 3;

  /* Block red */
  triplet.blue = 0x01;
  triplet.green = 0xb4;
  triplet.red = 0xf7;
  for (i = 0; i < SCREEN_WIDTH * nbline; i++)
    {
     // triplet.red = i % 256;
      *pixels++ = triplet;
    }
  /* Block blue */
  triplet.red = 0xff;
  triplet.blue = 0x1a;
  triplet.green = 0x11;
  for (i = 0; i < SCREEN_WIDTH * nbline; i++)
    {
      //triplet.blue = i % 256;
      *pixels++ = triplet;
    }
  /* Block green */
  triplet.red = 0;
  triplet.blue = 0;
  for (i = 0; i < SCREEN_WIDTH * nbline; i++)
    {
      triplet.green = i % 256;
      *pixels++ = triplet;
    }
  memcpy (pscreen->pixels, ppixels, SCREEN_HEIGHT * SCREEN_WIDTH * bpp);
   printscreen (pscreen->pixels, 10,20,8,"VGA QVGA QCIF CIF PAL QPAL :))",SCREEN_WIDTH,SCREEN_HEIGHT,0x00000000,0);
  int len =strlen(contrast); 
  for(i=0; i < len ; i++)
  {
   printchar (pscreen->pixels, 200,10+nbline+i*16,8,contrast[i],SCREEN_WIDTH,0x00000000,0);
   }
   printscreen (pscreen->pixels, 10,10+2*nbline,8,"Oh le beau Vert que voila ! qu'il est beau :))",SCREEN_WIDTH,SCREEN_HEIGHT,0x0000ff00,0xffffff00);
  SDL_UpdateRect (pscreen, 0, 0, 0, 0);
  while (run)
    {
      if (SDL_WaitEvent (&sdlevent) == 1)
	// if (SDL_PollEvent (&sdlevent) == 1)
	{
	  switch (sdlevent.type)
	    {
	    case SDL_KEYDOWN:
	      switch (sdlevent.key.keysym.sym)
		{
		case SDLK_q:
		  run = 0;
		  break;
		case SDLK_UP:
		  break;
		case SDLK_DOWN:
		  break;
		default:
		  break;
		}
	      break;
	    case SDL_QUIT:
	      break;
	    }
	}
    }
  free (ppixels);
  SDL_Quit ();
}
