#define ADDRESSE(x,y,w) (((y)*(w))+(x))

typedef struct YU {
    unsigned char Y0;
    unsigned char U0;
} YU;

/* Each pixels in the resulting figure need to be set. For each one take the nearest available in the original surface
If the last Chroma component is U take a V else take U by moving the index in the nearest pixel from the left 
This routine only deal with X axis you need to make the original picture with the good height */

static int resize(unsigned char *INbuff, unsigned char *OUTbuff,
		  int Owidth, int Oheight, int width, int height)
{
    int rx, ry;
    int xscale,yscale;
    int x, y;
    int Cc, lastCc;
    YU *input = (YU *) INbuff;
    YU *output = (YU *) OUTbuff;
    if (!width || !height)
	return -1;
    /* at start Cc mean a U component so LastCc should be a V */
    lastCc = 1;
    xscale = (Owidth << 16) / width;
    yscale =(Oheight << 16) / height;
    
    for (y = 0; y < height; y++) {
	for (x = 0; x < width; x++) {
	    rx = x * xscale >> 16;
	    ry = y * yscale >> 16;
	    if (((2 * rx + 1) & 0x03) == 3)
		Cc = 1;		// find V component
	    else
		Cc = 0;
	    if (lastCc == Cc) {
		/* no Chroma interleave correct by moving the index */
		rx -= 1;
		Cc = !Cc;
	    }
	    memcpy(output++, &input[ADDRESSE((int) rx, (int) ry, Owidth)],
		   sizeof(YU));
	    lastCc = Cc;
	}
    }
    return 0;
} 
