/****************************************************************************
#	 	GspcaGui:  Gspca/Spca5xx Grabber                            #
# 		Copyright (C) 2004 2005 2006 Michel Xhaard                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/ 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <linux/types.h>
#include <string.h>
#include <fcntl.h>
#include <wait.h>
#include <time.h>
#include <limits.h>
#include <errno.h>
#include <pthread.h>
#include <pwd.h>

#include "../converter/cvrt.h"
#include "../encoder/encoder.h"
#include "../decoder/decoder.h"
#include "../display.h"
#include "picture.h"

extern struct passwd *mypasswd;	
extern int debug;

static int nbpict = 0;

double
ms_time (void)
{
  static struct timeval tod;
  gettimeofday (&tod, NULL);
  return ((double) tod.tv_sec * 1000.0 + (double) tod.tv_usec / 1000.0);

}
double
us_time (void)
{
  static struct timeval tod;
  gettimeofday (&tod, NULL);
  return ((double) tod.tv_sec * 1000000.0 + (double) tod.tv_usec );

}
static void
getFileName (char *name, int format)
{
  char temp[80];
  char *myext[] = { "avi", "pnm", "jpg" };
  int i;
  time_t curdate;
  struct tm *tdate;
  memset (temp, '\0', sizeof (temp));
  time (&curdate);
  tdate = localtime (&curdate);
  snprintf (temp, 31, "%02d:%02d:%04d-%02d:%02d:%02d-P%04d.%s\0",
	    tdate->tm_mon + 1, tdate->tm_mday, tdate->tm_year + 1900,
	    tdate->tm_hour, tdate->tm_min, tdate->tm_sec, nbpict++, myext[format]);
  memcpy (name, temp, strlen (temp));
}

static void
getJpegPicture(char *path,int quality, picture_t *mypicture)
{
 FILE *out_file;
 char name[80];
 char ipath[255];
 char spcadir[] ="spcagui/";
 int len;
 unsigned char *out = NULL;
 unsigned char *outp;
 int size;
 
 len = strlen(path);
 memset(name,0,strlen(name));
 memset(ipath,0,strlen(ipath));
 snprintf(ipath,len+2,"%s/",path);
 getFileName(name,2);
 strcat(ipath,spcadir);
 if(mkdir(ipath,0770)!= 0){
   if(errno != EEXIST)
      return;
 }
  strcat(ipath,name);
 printf("%s\n",ipath);
 size = mypicture->ow*mypicture->oh << 1;
 out = malloc(size);
 if(!out) 
 	return;
outp = out;
 if (resize_bilinear(&mypicture->S,&mypicture->w,&mypicture->h,mypicture->ow,mypicture->oh) <0){
	printf("error fatal bilinear\n");
	goto err;
}
printf("resize done \n");
	size = encode_image(mypicture->S,outp,quality,Pyuv422trPyuv422,mypicture->w,mypicture->h);
	
if(size >0){
	out_file = fopen (ipath, "wb");
  	fwrite (outp, 1, size, out_file);
  	fclose (out_file);
	}
printf("picture done \n");
err:
	free(out);

}
void *waitandshoot(void* ptr)
{ 
video_screen_t *screen = (video_screen_t *) ptr;
picture_t *mypict = (picture_t *) &screen->screenshot;
	
	int status;
while(1){
    status = pthread_mutex_lock (&mypict->condition_mutex);
    if (status != 0) {fprintf(stderr,"Lock error!\n"); goto err;}
	while (screen->pictflag == 0) {
              /* Set predicate */
 	status = pthread_cond_wait(&mypict->condition_cond, &mypict->condition_mutex);
    if (status != 0) {fprintf(stderr,"Wait error!\n"); goto err;}
 	}
	screen->pictflag = 0;
	getJpegPicture(screen->path,128,mypict);
    status = pthread_mutex_unlock (&mypict->condition_mutex);
    if (status != 0) {fprintf(stderr,"Unlock error!\n"); goto err;}
    /******* EXIT the MONITOR ************/
// printf("Condition was accept, data.value=%d\n",pictFlag);

}
err:
    return NULL;	
}
avi_t *aviOpen(char *path,videoIn_t *vd){
	avi_t *avi_fd = NULL;
	char name[80];
 	char ipath[255];
 	char spcadir[] ="spcagui/";
	int len;
	 len = strlen(path);
 	memset(name,0,strlen(name));
 	memset(ipath,0,strlen(ipath));
 	snprintf(ipath,len+2,"%s/",path);
 	getFileName(name,0);
 	strcat(ipath,spcadir);
 	if(mkdir(ipath,0770)!= 0){
   		if(errno != EEXIST)
      		return NULL;
 	}
  	strcat(ipath,name);
 	printf("%s\n",ipath);
	if(!(avi_fd = AVI_open_output_file (ipath))){
		printf ("cannot open avi write file ? \n");
	       return NULL;
	}
	AVI_set_video (avi_fd, vd->hdrwidth, vd->hdrheight, 20, "MJPG");
	return avi_fd;
}

void
aviClose (avi_t *avi_fd,record_data_t *rdata)
{
  double tottime = 0;
  if (avi_fd)
    {
      printf ("AVI close asked \n");
      rdata->timeoff = us_time ();
      tottime = rdata->timeoff-rdata->timeon;
      
      if (tottime > 0)
	avi_fd->fps = (double) rdata->nbframe *1000000 / tottime;

      AVI_close (avi_fd);
      printf ("close avi\n");
      avi_fd = NULL;
    }

}

int getaviframe(unsigned char *buf,int w,int h, int *frame,videoIn_t *vd)
{
int i;
int framesize = 0;
int qual = 128;
int image_format;
unsigned char *buftmp = NULL;

if (debug ) printf("enter getaviframe\n");	
 while ((*frame == vd->framecour) && vd->signalquit) usleep(1000);
       if (vd->signalquit){
	vd->framebuffer[*frame].readlck++;
	if(debug) printf("buffersize %d width %d height %d\n",vd->framebuffer[*frame].size,vd->framebuffer[*frame].w,
		vd->framebuffer[*frame].h);
		if((w != vd->framebuffer[*frame].w) || (h != vd->framebuffer[*frame].h)){
		printf("Damned the stream is not compliant to the data struct ?? \n");
		vd->framebuffer[*frame].readlck--;
		return -1;
		}
		switch (vd->formatIn){
	    case VIDEO_PALETTE_JPEG:
	    	for (i = 0 ; i < vd->framebuffer[*frame].size; i++){
			buf[i]= vd->framebuffer[*frame].data[i];
			if(vd->framebuffer[*frame].data[i] == 0xff && vd->framebuffer[*frame].data[i+1] == 0xd9){
			          buf[i+1] = 0xd9;
			           break;
			}
		}
	          framesize = i+2;
            break;
            case VIDEO_PALETTE_RAW:
               {
	            memcpy(buf,vd->framebuffer[*frame].data,vd->framebuffer[*frame].size);
		    framesize = vd->framebuffer[*frame].size;
               }
            break;
            case VIDEO_PALETTE_YUV420P:
	    buftmp = malloc(w*h*2);
	    image_format = yuv420PtoPyuv422(vd->framebuffer[*frame].data,buftmp,w,h);
	    framesize = encode_image(buftmp,buf,qual,Pyuv422trPyuv422,w,h);
	    free(buftmp);
	    buftmp = NULL;
            break;   
            case VIDEO_PALETTE_YUV420:
	    framesize = encode_image(vd->framebuffer[*frame].data,buf,qual,Pyuv420trPyuv420,w,h);
            break;
	    case VIDEO_PALETTE_YUV422P:
	    framesize = encode_image(vd->framebuffer[*frame].data,buf,qual,yuv422PtrPyuv422,w,h);
	    break;
            case VIDEO_PALETTE_YUV422:
	    framesize = encode_image(vd->framebuffer[*frame].data,buf,qual,Pyuv422trPyuv422,w,h);
            break;
            case VIDEO_PALETTE_RGB565: 
	    buftmp = malloc(w*h*2);
	    image_format = rgb565toPyuv422(vd->framebuffer[*frame].data,buftmp,w,h);
	    framesize = encode_image(buftmp,buf,qual,Pyuv422trPyuv422,w,h);
	    free(buftmp);
	    buftmp = NULL;
            break;
            case VIDEO_PALETTE_RGB24:
	    buftmp = malloc(w*h*2);
	    image_format = rgb24toPyuv422(vd->framebuffer[*frame].data,buftmp,w,h);
	    framesize = encode_image(buftmp,buf,qual,Pyuv422trPyuv422,w,h);
	    free(buftmp);
	    buftmp = NULL;
            break;
            case VIDEO_PALETTE_RGB32:
	     buftmp = malloc(w*h*2);
	    image_format = rgb32toPyuv422(vd->framebuffer[*frame].data,buftmp,w,h);
	    framesize = encode_image(buftmp,buf,qual,Pyuv422trPyuv422,w,h);
	    free(buftmp);
	    buftmp = NULL;
            break;
            default:
     		printf(" No converter found exit \n");
		return -1;
            break;
	}		
	vd->framebuffer[*frame].readlck--;
	*frame = (*frame+1)% NBUFFER;
	}
return framesize;
}

void *recordavi(void *ptr)
{
record_data_t *rdata = (record_data_t *) ptr;
videoIn_t *vd = rdata->vd;
avi_t *avi_fd = NULL;
unsigned char *buf = NULL;

int w,h;
int framesize = 0;
int rec =1;

int keyframe = 0;

if(!rdata->record_ON)
	return NULL;
if(!vd->streamon)
	return NULL;
	w= vd->hdrwidth;
	h = vd->hdrheight;
	buf = (unsigned char*) malloc(vd->framesizeIn);
	avi_fd = aviOpen(mypasswd->pw_dir,vd);
	rdata->nbframe=0;
	rdata->framecour=0;
	rdata->timeon = us_time ();
	rdata->timeoff = rdata->timeon;
while(rdata->record_ON && vd->streamon) {
	if((framesize = getaviframe(buf,w,h,&rdata->framecour,vd)) < 0){
		printf("error get aviframe \n");
		break;
		}
	rdata->nbframe++;	
	if(framesize)
	   if (AVI_write_frame (avi_fd,
			       (unsigned char *) buf, framesize,keyframe) < 0)
			       printf(" avi write error \n");
}
aviClose(avi_fd,rdata);
free(buf);
printf ("thread AVI quit \n");
return NULL;	
}
