/****************************************************************************
#	 	GspcaGui:  Gspca/Spca5xx Grabber                            #
# 		Copyright (C) 2004 2005 2006 Michel Xhaard                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/ 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <wait.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <errno.h>

#include "gui_internal.h"
#include "msgipc.h"
 
struct button photo,avi,spause,fliprgb,quit,sound,grab,play,client; 
struct potentiometre color, contrast, bright,denoise,sharpness;
struct control palette, size;
struct pad padcontrol;
struct toglesw togqual,togfrm,togauto;
struct ecran mecran;


void free_spcagui (void);

void
initialize (SDL_Surface *screen)
{
  /* initialize widget */  
  init_button (PHOTO, 0, 0, 0, &photo);
  init_button (AVI, 0, 48, 0, &avi);
  init_button (PAUSE, 0, 96, 0, &spause);
  init_button (FLIPRGB, 0, 144, 0, &fliprgb);
  init_button (QUIT, 0, 192, 0, &quit);
  init_potentiometre (COLOR,255, 96, 48, &color);  
  init_potentiometre (CONTRAST, 128, 48, 48, &contrast);
  init_potentiometre (BRIGHT, 128, 0, 48, &bright);    
  init_control (SIZE, 0x83, 8, 144, 48,&size);
  init_control (PALETTE, 0x0e, 6, 192, 48,&palette);
  init_button (SOUND, 0, 192, 240, &sound);
  init_pad(ROTATE,0,48,288,&padcontrol);
  init_potentiometre (DENOISE, 0, 0, 288, &denoise);
  init_potentiometre (SHARP, 128, 192, 288, &sharpness); 
  init_togle(FRMRATE,01,48,384,&togfrm);
  init_togle(QUALITY,01,96,384,&togqual);
  init_togle(AUTO,0x10,144,384,&togauto); 
  init_button (GRABBER, 0, 0, 432, &grab);
  init_button (PLAYER, 0, 48, 432, &play);
  init_button (CLIENT, 0, 96, 432, &client);
  init_info(INFO,144,432,&mecran);
  draw_button (&photo, screen);
  draw_button (&avi, screen);
  draw_button (&spause, screen);
  draw_button (&fliprgb, screen);
  draw_button (&quit, screen); 
  draw_potentiometre (&color, screen); 
  draw_potentiometre (&contrast, screen);
  draw_potentiometre (&bright, screen);   
  draw_control (&size, screen);
  draw_control (&palette, screen);
  draw_button (&sound, screen);
  draw_pad(&padcontrol,screen);
  draw_potentiometre (&denoise, screen);
  draw_potentiometre (&sharpness, screen);
  draw_togle(&togqual, screen);
  draw_togle(&togfrm, screen);
  draw_togle(&togauto, screen);
  draw_button (&grab, screen);
  draw_button (&play, screen);
  draw_button (&client, screen);
  draw_info(&mecran, screen);  	
}

void
free_spcagui (void)
{
  free_button (&photo);
  free_button (&avi);
  free_button (&spause); 
  free_button (&fliprgb);
  free_button (&quit);
  free_potentiometre (&color);  
  free_potentiometre (&contrast);
  free_potentiometre (&bright);
  free_control (&palette);
  free_control (&size);
  free_button (&sound);
  free_pad(&padcontrol);
  free_potentiometre (&denoise);
  free_potentiometre (&sharpness);
  free_togle(&togqual);
  free_togle(&togfrm);
  free_togle(&togauto);
  free_button (&grab);
  free_button (&play);
  free_button (&client);
  free_info(&mecran);
}

void set_title(int x, int y,action_gui action)
{
	switch (action) {
	 case BRIGHT:
	  SDL_WM_SetCaption ("Brightness ", "Control");
	  break;
	  case CONTRAST:
	  SDL_WM_SetCaption ("Contrast ", "Control");
	  break;
	  case COLOR:
	  SDL_WM_SetCaption ("Colors ", "Control");
	  break;
	  case DENOISE:
	  SDL_WM_SetCaption ("De Noise Filter ", "Control");
	  break;
	  case SHARP:
	  SDL_WM_SetCaption ("Sharpness ", "Control");
	  break;
	  case FRMRATE:
	  SDL_WM_SetCaption ("Up/Down framerate", "Control");
	  break;
	  case QUALITY:
	  SDL_WM_SetCaption ("Up/Down Quality ", "Control");
	  break;
	  case AUTO:
	  SDL_WM_SetCaption ("On/Off Exposure/WhiteBal.", "Control");
	  break;
	  case ROTATE:
	  SDL_WM_SetCaption ("Magic/Rot 90 180 270 ", "Control");
	  break;
	  case SIZE:
	   SDL_WM_SetCaption ("Adjust Size ", "Control");
	  break;
	  case AVI:
	  SDL_WM_SetCaption ("Start/Stop AVI Record", "Control");
	  break;
	  case PALETTE:
	  SDL_WM_SetCaption ("Change Palette", "Control");
	  break;
	  case PHOTO:
	  SDL_WM_SetCaption ("Take a picture !!", "Control");
	  break;
	  case PAUSE:
	  SDL_WM_SetCaption ("Pause ", "Control");
	  break;
	  case FLIPRGB:
	  SDL_WM_SetCaption ("RGB to BGR Filter", "Control");
	  break;
	  case SOUND:
	  SDL_WM_SetCaption ("Sound On/Off", "Control");
	  break;
	  case QUIT:
	  SDL_WM_SetCaption ("Bye Bye :)", "Control");
	  break;
	  default:
	  SDL_WM_SetCaption ("Remote controle", "Control");
	  break;
	}
}

static int ispot( action_gui action )
{
	switch (action){
	case BRIGHT:
	case CONTRAST:
	case DENOISE:
	case COLOR:
	case SHARP:
		return 1;
	default:
		return 0;
	}
}
static int isrefresh (action_gui action)
{
	switch (action) {
	case PLAYER:
	case GRABBER:
	case CLIENT:
		return 1;
	default:
		return 0;
	}
}
void
telecom (void)
{
  
  SDL_Surface *screen;
  Uint32 video_flags, lib_flags;
  SDL_Event event;
  action_gui action,last_action;
  unsigned char message[2];

  lib_flags = SDL_INIT_VIDEO;
  //video_flags = (SDL_HWPALETTE | SDL_DOUBLEBUF | SDL_NOFRAME);
  video_flags = (SDL_HWPALETTE | SDL_DOUBLEBUF);
  pid_t my_pid;
  struct request req;
  struct answer callback;
  int palavail = 0;
  int curpal = 0;
  
  int run = 1;
  int mavi = 1;
  int pause = 1;
  int mouseon = 0;
  int mousey = 0;
  int ycour = 0;
  action_gui curmode = NOTHING;
  
  my_pid = getpid();
	req.my_pid = my_pid;
	req.type = 1;
	
  if (SDL_Init (lib_flags) < 0)
    {
      fprintf (stderr, "Couldn't initialize SDL: %s\n", SDL_GetError ());
      exit (EXIT_FAILURE);
    }
  putenv ("SDL_VIDEO_WINDOW_POS=10,10");  
  screen = SDL_SetVideoMode (TELECOM_X, TELECOM_Y, 24, video_flags);
  SDL_ShowCursor (1);
  SDL_WM_SetCaption ("Remote Control", "Control");
  initialize(screen);
  SDL_Flip (screen);

while ((SDL_WaitEvent (&event) >= 0) && (run))
    {
    memset (message, 0x00, sizeof (message));
    	 if (event.type == SDL_MOUSEBUTTONUP)
	{
	// printf ("reset smooth potentiometers \n");
        mouseon = 0;
	} 
	/* Determine if a button has been clicked */
      if (event.type == SDL_MOUSEBUTTONDOWN)
	{
	  int x, y;
	  SDL_GetMouseState (&x, &y);
	  action = witchButton(x,y);
	  if(ispot(action)) {
	  	mouseon =1;
	  	mousey = event.button.y;
	  }
	  switch(action){
	  case BRIGHT:
		process_potentiometre (mousey, &bright, screen, message);
	  break;
	  case CONTRAST:
		process_potentiometre (mousey, &contrast, screen, message);
	  break;
	  case COLOR:
		process_potentiometre (mousey, &color, screen, message);
	  break;
	  case DENOISE: 
		process_potentiometre (mousey, &denoise, screen, message);
	  break;
	  case SHARP:
		process_potentiometre (mousey, &sharpness, screen, message);
	  break;
	  case SIZE:
	   process_control (y, &size, screen, message);
	  break;
	  case AVI:
	  process_button (1, &avi, screen, message);
	  break;
	  case PALETTE:
	  process_control (y, &palette, screen, message);
	  break;
	  case PHOTO:
	  process_button (0, &photo, screen, message);
	  break;
	  case PAUSE:
	  process_button (1, &spause, screen, message);
	  break;
	  case FLIPRGB:
	   process_button (1, &fliprgb, screen, message);
	  break;
	  case ROTATE:
	   process_pad (x,y, &padcontrol, screen, message);
	  break;
	  case QUIT:
	  process_button (1, &quit, screen, message);
	  run = 0;
	  break;
	  case FRMRATE:
	   process_togle (y, &togfrm, screen, message);
	  break;
	  case QUALITY:
	   process_togle (y, &togqual, screen, message);
	  break;
	  case AUTO:
	  process_togle (y, &togauto, screen, message);
	  break;
	  case GRABBER:
	  if( curmode == NOTHING || curmode == GRABBER){
	       process_button (1, &grab, screen, message);
	  if (message[1]) curmode = GRABBER;
	  else curmode = NOTHING;
	  }
	  //refresh_button(PLAYER,0,&play,screen);
	  //refresh_button(CLIENT,0,&client,screen);
	  break;
	  case PLAYER:
	  if( curmode == NOTHING || curmode == PLAYER){
	      process_button (1, &play, screen, message);
	  if (message[1]) curmode = PLAYER;
	  else curmode = NOTHING;
	  }
	  //refresh_button(GRABBER,0,&grab,screen);
	  //refresh_button(CLIENT,0,&client,screen);
	  break;
	  case CLIENT:
	  if( curmode == NOTHING || curmode == CLIENT){
	       process_button (1, &client, screen, message);
	  if (message[1]) curmode = CLIENT;
	  else curmode = NOTHING;
	  }
	  //refresh_button(GRABBER,0,&grab,screen);
	  //refresh_button(PLAYER,0,&play,screen);
	  break;
	  }
	  }
    	if (event.type == SDL_MOUSEMOTION)
	{
	int x, y;
	  SDL_GetMouseState (&x, &y);
	  action = witchButton(x,y);
	  if(last_action != action){
	  	set_title(x,y,action);
	  	last_action = action;
	  }
	  if(ispot(action) && mouseon){
	  	ycour = y - mousey;
	    if ((ycour > 2) || (ycour < -2 )){
		mousey = mousey + ycour;	
	  switch(action){
	  case BRIGHT:	 
		process_potentiometre (mousey, &bright, screen, message);
	  break;
	  case CONTRAST:	 
		process_potentiometre (mousey, &contrast, screen, message);
	  break;
	  case COLOR:	 
		process_potentiometre (mousey, &color, screen, message);
	  break;
	  case DENOISE:	 
		process_potentiometre (mousey, &denoise, screen, message);
	  break;
	  case SHARP:	  
		process_potentiometre (mousey, &sharpness, screen, message);
	  break;
	  }
	  }
	  }
	 } 
	
	  if (message[0] != 0) {
	  req.act = (action_gui)message[0];
	  req.val = message[1];
	  if(sendRequest(mid,&req,flags) < 0)
	       printf("send request errors %d\n",req.act);
	       printf("send %d mid, (%d) action, (%d) value \n",mid,req.act,req.val);
	  if(req.act == PALETTE){
/* A change on palette can make the size change so update what is available */
	  	if((palavail=getMessagebyId(mid,SIZE,&callback,my_pid,0)) < 0)
		  printf("Error get palette available \n");
		if((curpal=getMessagebyId(mid,SIZE,&callback,my_pid,0)) < 0)
		  printf("Error get palette current \n");	 
		refresh_control(palavail,curpal,&size,screen);
	  }  
	  if(isrefresh(req.act)&& req.val) {
/* warning blocking read when Mode change to ON */
               printf("waiting for the messages from the grabber \n");
	       if((palavail=getMessage(mid,&callback,my_pid,0)) < 0)
		 printf("Error get Mode available \n");	
	       process_info(callback.mess,&mecran,screen);		
/* here we should wait until probe finish to update the remote control 
This sequence is only set when you change the mode Player Grabber or Client*/
if(curmode == GRABBER){	   	
	       if((palavail=getMessagebyId(mid,PALETTE,&callback,my_pid,0)) < 0)
		 printf("Error get palette available \n");	
	       if((curpal=getMessagebyId(mid,PALETTE,&callback,my_pid,0)) < 0)
		 printf("Error get palette current \n");	
	       refresh_control(palavail,curpal,&palette,screen);
	       if((palavail=getMessagebyId(mid,SIZE,&callback,my_pid,0)) < 0)
		 printf("Error get size available \n");	
	       if((curpal=getMessagebyId(mid,SIZE,&callback,my_pid,0)) < 0)
		 printf("Error get size current \n");	
	       refresh_control(palavail,curpal,&size,screen);
	       if((curpal=getMessagebyId(mid,BRIGHT,&callback,my_pid,0)) < 0)
		 printf("Error get bright current \n");
	       refresh_potentiometre (BRIGHT,curpal, &bright, screen); 
	       if((curpal=getMessagebyId(mid,CONTRAST,&callback,my_pid,0)) < 0)
		 printf("Error get contrast current \n");
	       refresh_potentiometre (CONTRAST,curpal, &contrast, screen); 
	       if((curpal=getMessagebyId(mid,COLOR,&callback,my_pid,0)) < 0)
		 printf("Error get colors current \n");
	       refresh_potentiometre (COLOR,curpal, &color, screen); 
	       }
	   }
	  }

    }

   free_spcagui ();
  SDL_Quit ();
}
