 
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>
#include <signal.h>
#include "libv4l.h"

videoIn_t *videoIn = NULL;

void grabber (void);
void sigchld_handler(int s);

int fd = 0;
int
main (int argc, char *argv[])
{
int i;
 char *videodevice = NULL;
 int frameread = 0;
 int frame = 0;
 pthread_t w1;
 int err;
 struct sigaction sa;
 
  for (i = 1; i < argc; i++)
    {
      /* skip bad arguments */
      if (argv[i] == NULL || *argv[i] == 0 || *argv[i] != '-')
	{
	  continue;
	}
      if (strcmp (argv[i], "-d") == 0)
	{
	  if (i + 1 >= argc)
	    {
	      printf ("No parameter specified with -d, aborting.\n");
	      exit (1);
	    }
	  videodevice = strdup (argv[i + 1]);
	}
 }
  if (videodevice == NULL || *videodevice == 0)
    {
      videodevice = "/dev/video0";
    }
    videoIn = openvideo(videodevice);
    if((err= pthread_create (&w1, NULL, (void *) grabber, NULL)) != 0){
	printf("thread grabbing error %d \n",err);
	 closevideo(videoIn);
	exit(1);
 }
 	sa.sa_handler = sigchld_handler;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = SA_RESTART;
	videoIn->signalquit=1;
	streamstart (videoIn);
	while (videoIn->signalquit){
	while ((frameread == videoIn->framecour) && videoIn->signalquit) usleep(1000);
       if (videoIn->signalquit){
	videoIn->framebuffer[frameread].readlck++;
	printf("buffersize %d width %d height %d\n",videoIn->framebuffer[frameread].size,videoIn->framebuffer[frameread].w,
		videoIn->framebuffer[frameread].h);
	videoIn->framebuffer[frameread].readlck--;
	frameread = (frameread+1)% NBUFFER;
	}
	usleep(50000);
	frame++;
	if (frame == 25){
	streamstop(videoIn);
	printf("input change size %d \n",frame);
	changeSize (videoIn,CIF );
	streamstart (videoIn);
	}
	if (frame == 50){
	printf("input change palette %d \n",frame);
	streamstop(videoIn);
	setPalette (videoIn,YUV420P );
	streamstart (videoIn);
	}
	if (frame == 100){
	printf("input change size %d \n",frame);
	streamstop(videoIn);
	changeSize (videoIn,VGA );
	streamstart (videoIn);
	}
	if (frame == 150){
	printf("Quitter %d \n",frame);
	videoIn->signalquit=0;
	break;
	}
	}
	// pthread_cancel (w1);
	streamstop(videoIn);
	pthread_join (w1, NULL);
    closevideo(videoIn);
    
}

void
grabber (void)
{
int err = 0;
  for (;;)
    {
      //printf("I am the GRABBER !!!!! \n");
      err = grabone(videoIn);
      if (!videoIn->signalquit || (err < 0)){
      printf("GRABBER going out !!!!! \n");
	break;
	}
    }
}
void sigchld_handler(int s)
{
	videoIn->signalquit = 0;
}
