
#ifndef SONIXUSB_H
#define SONIXUSB_H
/****************************************************************************
#	 	sonix sn9c102 library                                       #
# 	Copyright (C) 2003 2004 2006 Michel Xhaard   mxhaard@magic.fr       #
# Add Pas106 Stefano Mozzi (C) 2004 	 				    #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/

#define COMP2 0x8F
#define COMP 0xC7		//0x87 //0x07
#define COMP1 0xC9		//0x89 //0x09

#define MCK_INIT 0x63
#define MCK_INIT1 0x20

#define SYS_CLK 0x04
/*******************     Camera Interface   ***********************/
static int sonix_init(struct gspca_device *gspca_dev);
static int sonix_config(struct gspca_device *gspca_dev);
static void sonix_start(struct gspca_device *gspca_dev);
static void sonix_stopN(struct gspca_device *gspca_dev);
static void sonix_stop0(struct gspca_device *gspca_dev);
static void sonix_shutdown(struct gspca_device *gspca_dev);
static int sonix_sofdetect(struct gspca_device *gspca_dev,
			   struct gspca_rawframe *frame, unsigned char *cdata,
			   int *iPix, int seqnum, int *datalength);
static int sonix_set_control(struct gspca_device *gspca_dev,struct v4l2_control *ctrl);
static int sonix_get_control(struct gspca_device *gspca_dev,struct v4l2_control *ctrl);
static int sonix_query_control(struct gspca_device *gspca_dev,struct v4l2_queryctrl *q_ctrl);
static int
gspca_check_sonix(struct gspca_device *gspca_dev, __u16 vendor, __u16 product);
static int 
gspca_attach_sonix(struct gspca_device *gspca_dev);
			   
/******************************************************************/			   
static __u16 sonix_getbrightness(struct gspca_device *gspca_dev);
static void sonix_setbrightness(struct gspca_device *gspca_dev);
static void sonix_setcontrast(struct gspca_device *gspca_dev);
static __u16 sonix_getcontrast(struct gspca_device *gspca_dev);
static void sonix_setcolors(struct gspca_device *gspca_dev);
static __u16 sonix_getcolors(struct gspca_device *gspca_dev);
static void sonix_setAutobright(struct gspca_device *gspca_dev);
static void sonix_setquality(struct gspca_device *gspca_dev);

/******************************************************************/
static void
sonix_setcolors(struct gspca_device *gspca_dev)
{
}
static __u16
sonix_getcolors(struct gspca_device *gspca_dev)
{
	return 0;
}
static void
sonix_shutdown(struct gspca_device *gspca_dev)
{
}
static void
sonix_setAutobright(struct gspca_device *gspca_dev)
{
}
static void
sonix_setquality(struct gspca_device *gspca_dev)
{
}
static void
sonix_stop0(struct gspca_device *gspca_dev)
{
}

/*****************************************************************/
#include "sn9cxxx.h"
static struct cam_operation fsonix = {
	.initialize = sonix_init,
	.configure = sonix_config,
	.start = sonix_start,
	.stopN = sonix_stopN,
	.stop0 = sonix_stop0,
	.cam_shutdown = sonix_shutdown,
	.sof_detect = sonix_sofdetect,
	.set_ctrl = sonix_set_control,
	.get_ctrl = sonix_get_control,
	.query_ctrl = sonix_query_control,
	
};
static struct v4l2_queryctrl sonix_controls[GSPCATOT_CTRL] = {
        {
	    .id      = V4L2_CID_BRIGHTNESS,
	    .type    = V4L2_CTRL_TYPE_INTEGER,
	    .name    = "Brightness",
	    .minimum = 0,
	    .maximum = 255,
	    .step    = 1,
	    .default_value = 128,
	},
        {
	    .id      = V4L2_CID_CONTRAST,
	    .type    = V4L2_CTRL_TYPE_INTEGER,
	    .name    = "Contrast",
	    .minimum = 0,
	    .maximum = 255,
	    .step    = 1,
	    .default_value = 128,
	},
        {
	    .id      = V4L2_CID_SATURATION,
	    .type    = V4L2_CTRL_TYPE_INTEGER,
	    .name    = "Colors",
	    .minimum = 0,
	    .maximum = 255,
	    .step    = 1,
	    .default_value = 128,
	},
        {
	    .id      = V4L2_CID_AUTO_WHITE_BALANCE,
	    .type    = V4L2_CTRL_TYPE_BOOLEAN,
	    .name    = "Auto White Balance",
	    .minimum = 0,
	    .maximum = 1,
	    .step    = 1,
	    .default_value = 0,
	},
	{
	    .id      = V4L2_CID_AUTOGAIN,
	    .type    = V4L2_CTRL_TYPE_BOOLEAN,
	    .name    = "Auto Gain Enabled",
	    .minimum = 0,
	    .maximum = 1,
	    .step    = 1,
	    .default_value = 1,
	}
};
static void
set_sonixVGA(struct gspca_device *gspca_dev)
{
	struct stream_camera *camera = &gspca_dev->camera;
    	memset(camera->mode_cam, 0x00, TOTMODE * sizeof(struct mwebcam));
	
	camera->mode_cam[VGA].width = 640;
	camera->mode_cam[VGA].height = 480;
	if (camera->customid == SN9C102P || camera->customid == SN9C105
	    || camera->customid == SN9C120)
		camera->mode_cam[VGA].t_palette = P_JPEG;
	else 
		camera->mode_cam[VGA].t_palette = P_BAYER;	
	camera->mode_cam[VGA].mode = 0;	
	
	camera->mode_cam[CIF].width = 320;
	camera->mode_cam[CIF].height = 240;
	if (camera->customid == SN9C102P || camera->customid == SN9C105
	    || camera->customid == SN9C120)
		camera->mode_cam[CIF].t_palette = P_JPEG;
		else
		camera->mode_cam[CIF].t_palette = P_BAYER;
	camera->mode_cam[CIF].mode = 1;

	camera->mode_cam[QCIF].width = 160;
	camera->mode_cam[QCIF].height = 120;
	if (camera->customid == SN9C102P || camera->customid == SN9C105
	    || camera->customid == SN9C120)
		camera->mode_cam[QCIF].t_palette = P_JPEG;
		else
		camera->mode_cam[QCIF].t_palette = P_BAYER;
	camera->mode_cam[QCIF].mode = 2;

}
static void
set_sonixSIF(struct gspca_device *gspca_dev)
{
	struct stream_camera *camera = &gspca_dev->camera;
    	memset(camera->mode_cam, 0x00, TOTMODE * sizeof(struct mwebcam));
	
	camera->mode_cam[SIF].width = 352;
	camera->mode_cam[SIF].height = 288;
	if (camera->customid == SN9C102P || camera->customid == SN9C105
	    || camera->customid == SN9C120)
		camera->mode_cam[VGA].t_palette = P_JPEG;
	else 
		camera->mode_cam[VGA].t_palette = P_BAYER;	
	camera->mode_cam[SIF].mode = 0;	
	
	camera->mode_cam[QSIF].width = 176;
	camera->mode_cam[QSIF].height = 144;
	if (camera->customid == SN9C102P || camera->customid == SN9C105
	    || camera->customid == SN9C120)
		camera->mode_cam[QSIF].t_palette = P_JPEG;
		else
		camera->mode_cam[QSIF].t_palette = P_BAYER;
	camera->mode_cam[QSIF].mode = 1;

}

static __u8 initTas5130[] = {
	0x04, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x11, 0x00, 0x00, 0x00,
	0x00, 0x00,
	0x00, 0x01, 0x00, 0x69, 0x0c, 0x0a,
	0x28, 0x1e, 0x60, COMP, MCK_INIT,
	0x18, 0x10, 0x04, 0x03, 0x11, 0x0c
};

static __u8 initPas106[] = {
	0x04, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0x40, 0x00, 0x00, 0x00,
	0x00, 0x00,
	0x00, 0x00, 0x00, 0x05, 0x01, 0x00,
	0x16, 0x12, 0x28, COMP1, MCK_INIT1,
	0x18, 0x10, 0x04, 0x03, 0x11, 0x0c
};

static __u8 initOv7630[] = {
	0x04, 0x44, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x21, 0x00, 0x00, 0x00,
	0x00, 0x00,
	0x00, 0x00, 0x00, 0x02, 0x03, 0x0a,	//shift one pixel 0x02 is 0x01 at start
	0x28, 0x1e, 0x68, COMP1, MCK_INIT1,
	0x1d, 0x10, 0x02, 0x03, 0x0f, 0x0c
};
static __u8 initHv7131[] = {
	0x46, 0x77, 0x00, 0x04, 0x00, 0x00, 0x00, 0x80, 0x11, 0x00, 0x00, 0x00,
	0x00, 0x00,
	0x00, 0x00, 0x00, 0x03, 0x01, 0x00,	// shift from 0x02 0x01 0x00
	0x28, 0x1e, 0x60, 0x8a, 0x20,
	0x1d, 0x10, 0x02, 0x03, 0x0f, 0x0c
};
static __u8 initTas5110[] = {
	0x44, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x11, 0x00, 0x00, 0x00,
	0x00, 0x00,
	0x00, 0x01, 0x00, 0x46, 0x09, 0x0a,	// shift from 0x45 0x09 0x0a
	0x16, 0x12, 0x60, 0x86, 0x2b,
	0x14, 0x0a, 0x02, 0x02, 0x09, 0x07
};
static __u8 initPas202[] = {
	0x44, 0x44, 0x21, 0x30, 0x00, 0x00, 0x00, 0x80, 0x40, 0x00, 0x00, 0x00,
	0x00, 0x00,
	0x00, 0x00, 0x00, 0x07, 0x03, 0x0A,	//6
	0x28, 0x1e, 0x28, 0x89, 0x30,
	0x00, 0x00, 0x02, 0x03, 0x0F, 0x0C
};

//compression 0x86 mckinit1 0x2b
static __u8 pas106_data[][2] = {
	{0x02, 0x04},		/* Pixel Clock Divider 6 */
	{0x03, 0x13},		/* Frame Time MSB */
	//{ 0x03, 0x12}, /* Frame Time MSB */
	{0x04, 0x06},		/* Frame Time LSB */
	//{ 0x04, 0x05}, /* Frame Time LSB */
	{0x05, 0x65},		/* Shutter Time Line Offset */
	//{ 0x05, 0x6d}, /* Shutter Time Line Offset */
	//{ 0x06, 0xB1}, /* Shutter Time Pixel Offset */
	{0x06, 0xcd},		/* Shutter Time Pixel Offset */
	{0x07, 0xC1},		/* Black Level Subtract Sign */
	//{ 0x07, 0x00}, /* Black Level Subtract Sign */
	{0x08, 0x06}, /* Black Level Subtract Level */ {0x08, 0x06},	/* Black Level Subtract Level */
	//{ 0x08, 0x01}, /* Black Level Subtract Level */
	{0x09, 0x05},		/* Color Gain B Pixel 5 a */
	{0x0A, 0x04},		/* Color Gain G1 Pixel 1 5 */
	{0x0B, 0x04},		/* Color Gain G2 Pixel 1 0 5 */
	{0x0C, 0x05},		/* Color Gain R Pixel 3 1 */
	{0x0D, 0x00},		/* Color GainH  Pixel */
	{0x0E, 0x0E},		/* Global Gain */
	{0x0F, 0x00},		/* Contrast */
	{0x10, 0x06},		/* H&V synchro polarity */
	{0x11, 0x06},		/* ?default */
	{0x12, 0x06},		/* DAC scale */
	{0x14, 0x02},		/* ?default */
	{0x13, 0x01},		/* Validate Settings */
	{0, 0}			/* The end */
};
static __u8 ov7630_sensor_init[][8] = {
	{0xa0, 0x21, 0x12, 0x80, 0x00, 0x00, 0x00, 0x10},
	{0xb0, 0x21, 0x01, 0x77, 0x3a, 0x00, 0x00, 0x10},
	{0xd0, 0x21, 0x12, 0x78, 0x00, 0x80, 0x34, 0x10},
	{0xa0, 0x21, 0x1b, 0x04, 0x00, 0x80, 0x34, 0x10},
	{0xa0, 0x21, 0x20, 0x44, 0x00, 0x80, 0x34, 0x10},
	{0xa0, 0x21, 0x23, 0xee, 0x00, 0x80, 0x34, 0x10},
	{0xd0, 0x21, 0x26, 0xa0, 0x9a, 0xa0, 0x30, 0x10},
	{0xb0, 0x21, 0x2a, 0x80, 0x00, 0xa0, 0x30, 0x10},
	{0xb0, 0x21, 0x2f, 0x3d, 0x24, 0xa0, 0x30, 0x10},
	{0xa0, 0x21, 0x32, 0x86, 0x24, 0xa0, 0x30, 0x10},
	{0xb0, 0x21, 0x60, 0xa9, 0x42, 0xa0, 0x30, 0x10},
	{0xa0, 0x21, 0x65, 0x00, 0x42, 0xa0, 0x30, 0x10},
	{0xa0, 0x21, 0x69, 0x38, 0x42, 0xa0, 0x30, 0x10},
	{0xc0, 0x21, 0x6f, 0x88, 0x0b, 0x00, 0x30, 0x10},
	{0xc0, 0x21, 0x74, 0x21, 0x8e, 0x00, 0x30, 0x10},
	{0xa0, 0x21, 0x7d, 0xf7, 0x8e, 0x00, 0x30, 0x10},
	{0xd0, 0x21, 0x17, 0x1c, 0xbd, 0x06, 0xf6, 0x10},	//
	{0xa0, 0x21, 0x10, 0x36, 0xbd, 0x06, 0xf6, 0x16},	// exposure
	{0xa0, 0x21, 0x76, 0x03, 0xbd, 0x06, 0xf6, 0x16},
	{0xa0, 0x21, 0x11, 0x01, 0xbd, 0x06, 0xf6, 0x16},
	{0xa0, 0x21, 0x00, 0x10, 0xbd, 0x06, 0xf6, 0x15},	//gain
//{ 0xb0, 0x21, 0x2a, 0xc0, 0x3c, 0x06, 0xf6, 0x1d},//a0 1c,a0 1f,c0 3c frame rate ?line interval from ov6630
	{0xb0, 0x21, 0x2a, 0xa0, 0x1f, 0x06, 0xf6, 0x1d},
	{0, 0, 0, 0, 0, 0, 0, 0}
};
static __u8 tas5110_sensor_init[][8] = {
	{0x30, 0x11, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x10},
	{0x30, 0x11, 0x02, 0x20, 0xa9, 0x00, 0x00, 0x10},
	{0, 0, 0, 0, 0, 0, 0, 0}
};
static __u8 hv7131_sensor_init[][8] = {
	{0xc0, 0x11, 0x31, 0x38, 0x2a, 0x2e, 0x00, 0x10},
	{0xa0, 0x11, 0x01, 0x08, 0x2a, 0x2e, 0x00, 0x10},
	{0xb0, 0x11, 0x20, 0x00, 0xd0, 0x2e, 0x00, 0x10},
	{0xc0, 0x11, 0x25, 0x03, 0x0e, 0x28, 0x00, 0x16},
	{0xa0, 0x11, 0x30, 0x10, 0x0e, 0x28, 0x00, 0x15},
	{0, 0, 0, 0, 0, 0, 0, 0}
};
static __u8 pas202_sensor_init[][8] = {
	{0xA0, 0x40, 0x02, 0x03, 0x00, 0x00, 0x00, 0x10},
	{0xD0, 0x40, 0x04, 0x07, 0x34, 0x00, 0x09, 0x10},
	{0xD0, 0x40, 0x08, 0x01, 0x00, 0x00, 0x01, 0x10},
	{0xD0, 0x40, 0x0C, 0x00, 0x0C, 0x00, 0x32, 0x10},
	{0xD0, 0x40, 0x10, 0x00, 0x01, 0x00, 0x63, 0x10},
	{0xA0, 0x40, 0x15, 0x70, 0x01, 0x00, 0x63, 0x10},
	{0xA0, 0x40, 0x18, 0x00, 0x01, 0x00, 0x63, 0x10},
	{0xA0, 0x40, 0x11, 0x01, 0x01, 0x00, 0x63, 0x10},
	{0xA0, 0x40, 0x03, 0x56, 0x01, 0x00, 0x63, 0x10},
	{0xA0, 0x40, 0x11, 0x01, 0x01, 0x00, 0x63, 0x10},
	{0xB0, 0x40, 0x04, 0x07, 0x2A, 0x00, 0x63, 0x10},
	{0xB0, 0x40, 0x0E, 0x00, 0x3D, 0x00, 0x63, 0x10},

	{0xA0, 0x40, 0x11, 0x01, 0x3D, 0x00, 0x63, 0x16},
	{0xA0, 0x40, 0x10, 0x08, 0x3D, 0x00, 0x63, 0x15},
	{0xA0, 0x40, 0x02, 0x04, 0x3D, 0x00, 0x63, 0x16},
	{0xA0, 0x40, 0x11, 0x01, 0x3D, 0x00, 0x63, 0x16},
	{0xB0, 0x40, 0x0E, 0x00, 0x31, 0x00, 0x63, 0x16},
	{0xA0, 0x40, 0x11, 0x01, 0x31, 0x00, 0x63, 0x16},
	{0xA0, 0x40, 0x10, 0x0E, 0x31, 0x00, 0x63, 0x15},
	{0xA0, 0x40, 0x11, 0x01, 0x31, 0x00, 0x63, 0x16},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

static int
sonix_i2cwrite(struct usb_device *dev, __u8 * buffer, __u16 length)
{
	int retry = 60;
	__u8 ByteReceive = 0x00;
	/* is i2c ready */
	if (length > 8 || !buffer)
		return -1;
	sonixRegWrite(dev, 0x08, 0x08, 0x0000, buffer, length);
	while (retry--) {
		wait_ms(10);
		sonixRegRead(dev, 0x00, 0x08, 0x0000, &ByteReceive, 1);
		if (ByteReceive == 4)
			return 0;
	}
	return -1;
}

static __u16 sonix_initcontrol(struct gspca_device *gspca_dev)
{
	gspca_dev->stream_param.colors = sonix_controls[GSPCA_COLOR].default_value;
	gspca_dev->stream_param.brightness = sonix_controls[GSPCA_BRIGHT].default_value;
	gspca_dev->stream_param.contrast = sonix_controls[GSPCA_CONTRAST].default_value;
	gspca_dev->stream_param.autoexpo = sonix_controls[GSPCA_AUTOEXPO].default_value;
	return 0;
}
static __u16
sonix_getbrightness(struct gspca_device *gspca_dev)
{			
	return gspca_dev->stream_param.brightness;
}
static __u16
sonix_getcontrast(struct gspca_device *gspca_dev)
{			
	return gspca_dev->stream_param.contrast;
}
static void
sonix_setbrightness(struct gspca_device *gspca_dev)
{
	struct usb_device *dev = gspca_dev->dev;
	__u8 value;
	__u8 i2c[] = { 0x30, 0x11, 0x02, 0x20, 0x70, 0x00, 0x00, 0x10 };
	__u8 i2c1[] = { 0xA1, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x14 };
	__u8 i2cOV[] = { 0xa0, 0x21, 0x06, 0x36, 0xbd, 0x06, 0xf6, 0x16 };
	__u8 i2cp202[] = { 0xA0, 0x40, 0x10, 0x0E, 0x31, 0x00, 0x63, 0x15 };
	__u8 i2cpdoit[] = { 0xA0, 0x40, 0x11, 0x01, 0x31, 0x00, 0x63, 0x16 };
	__u8 i2cpexpo[] = { 0xB0, 0x40, 0x0e, 0x01, 0xab, 0x00, 0x63, 0x16 };
	if (gspca_dev->sensor == SENSOR_TAS5130C ||
	    gspca_dev->sensor == SENSOR_TAS5110) {
		value = (0xFF - gspca_dev->stream_param.brightness);
		i2c[4] = value & 0xFF;
		PDEBUG(4, "brightness %d :%d ", value, i2c[4]);
		if (sonix_i2cwrite(dev, i2c, 8) < 0)
			PDEBUG(0, "i2c error brightness");
	} else if (gspca_dev->sensor == SENSOR_PAS106) {
		i2c1[3] = gspca_dev->stream_param.brightness >> 3;
		i2c1[2] = 0x0e;;
		if (sonix_i2cwrite(dev, i2c1, 8) < 0)
			PDEBUG(0, "i2c error brightness");
		i2c1[3] = 0x01;
		i2c1[2] = 0x13;;
		if (sonix_i2cwrite(dev, i2c1, 8) < 0)
			PDEBUG(0, "i2c error brightness");
	} else if (gspca_dev->sensor == SENSOR_OV7630) {
		// change reg 0x06
		i2cOV[3] = gspca_dev->stream_param.brightness;
		if (sonix_i2cwrite(dev, i2cOV, 8) < 0)
			PDEBUG(0, "i2c error brightness");
	} else if (gspca_dev->sensor == SENSOR_PAS202) {
		// change reg 0x10
		i2cpexpo[4] = 0xff - gspca_dev->stream_param.brightness;
		
		if (sonix_i2cwrite(dev, i2cpexpo, 8) < 0)
			PDEBUG(0, "i2c error brightness");
		if (sonix_i2cwrite(dev, i2cpdoit, 8) < 0)
			PDEBUG(0, "i2c error brightness");
		i2cp202[3] =gspca_dev->stream_param.brightness >> 3;
		if (sonix_i2cwrite(dev, i2cp202, 8) < 0)
			PDEBUG(0, "i2c error brightness");
		if (sonix_i2cwrite(dev, i2cpdoit, 8) < 0)
			PDEBUG(0, "i2c error brightness");
	}
}
static void
sonix_setcontrast(struct gspca_device *gspca_dev)
{
	struct usb_device *dev = gspca_dev->dev;
	__u8 gain = 0;
	__u8 rgb_value = 0;
	gain = ( gspca_dev->stream_param.contrast >> 5) & 0x0F;
	/* red and blue gain */
	rgb_value = gain << 4 | gain;
	sonixRegWrite(dev, 0x08, 0x10, 0x0000, &rgb_value, 1);
	/* green gain */
	rgb_value = gain;
	sonixRegWrite(dev, 0x08, 0x11, 0x0000, &rgb_value, 1);
}
static int sonix_query_control(struct gspca_device *gspca_dev, struct v4l2_queryctrl *q_ctrl)
{
	int i;
	for (i = 0; i < GSPCATOT_CTRL; i++)
		if(q_ctrl->id == sonix_controls[i].id){
			memcpy(q_ctrl,&sonix_controls[i],sizeof(struct v4l2_queryctrl));
			return 0;
		}
	return -EINVAL;
}	
static int sonix_get_control(struct gspca_device *gspca_dev, struct v4l2_control *ctrl)
{
	switch(ctrl->id){
		case V4L2_CID_BRIGHTNESS:
			ctrl->value = sonix_getbrightness(gspca_dev);
		break;
		case V4L2_CID_CONTRAST:
			ctrl->value = sonix_getcontrast(gspca_dev);
		break;
		case V4L2_CID_SATURATION:
			ctrl->value = sonix_getcolors(gspca_dev);
		break;
		case V4L2_CID_AUTO_WHITE_BALANCE:
			ctrl->value = gspca_dev->stream_param.autoexpo;
		break;
		case V4L2_CID_AUTOGAIN:
			ctrl->value = gspca_dev->stream_param.autoexpo;
		break;
		default:
		return -EINVAL;
	}
	return 0;
}
static int sonix_set_control(struct gspca_device *gspca_dev, struct v4l2_control *ctrl)
{
	int i;
	for (i = 0; i < GSPCATOT_CTRL; i++)
		if(ctrl->id == sonix_controls[i].id){
			if ( ctrl->value >= sonix_controls[i].minimum &&
				ctrl->value <= sonix_controls[i].maximum ){
				PDEBUG(0, "Control value %d ",ctrl->value);
				switch(ctrl->id){
					case V4L2_CID_BRIGHTNESS:
						gspca_dev->stream_param.brightness = ctrl->value;
						sonix_setbrightness(gspca_dev);
					return 0;
					case V4L2_CID_CONTRAST:
						gspca_dev->stream_param.contrast = ctrl->value;
						sonix_setcontrast(gspca_dev);
					return 0;
					case V4L2_CID_SATURATION:
						gspca_dev->stream_param.colors = ctrl->value;
						sonix_setcolors(gspca_dev);
					return 0;
					case V4L2_CID_AUTO_WHITE_BALANCE:
						gspca_dev->stream_param.autoexpo = ctrl->value;
						sonix_setAutobright(gspca_dev);
					return 0;
					case V4L2_CID_AUTOGAIN:
						gspca_dev->stream_param.autoexpo = ctrl->value;
						sonix_setAutobright(gspca_dev);
					return 0;
					default:
						return -EINVAL;
				}
			} else
				return -ERANGE;
		}
	
	return -EINVAL;
}

static int
sonix_init(struct gspca_device *gspca_dev)
{
	__u8 ByteReceive = 0x00;
	sonixRegRead(gspca_dev->dev, 0x00, 0x00, 0x0000, &ByteReceive, 1);
	if (ByteReceive != 0x10)
		return -ENODEV;

	return 0;
}

static int
tas5130_I2cinit(struct gspca_device *gspca_dev)
{
	struct usb_device *dev = gspca_dev->dev;
	//__u8 i2c10[]= { 0x30,0x11,0x00,0x40,0x47,0x00,0x00,0x10 }; // shutter 0x47 short exposure?
	__u8 i2c10[] = { 0x30, 0x11, 0x00, 0x40, 0x01, 0x00, 0x00, 0x10 };	// shutter 0x01 long exposure 
	__u8 i2c2[] = { 0x30, 0x11, 0x02, 0x20, 0x70, 0x00, 0x00, 0x10 };

	if (sonix_i2cwrite(dev, i2c10, 8) < 0)
		PDEBUG(0, "i2c error i2c10");
	if (sonix_i2cwrite(dev, i2c2, 8) < 0)
		PDEBUG(0, "i2c error i2c2");

	return 0;
}

static int
pas106_I2cinit(struct gspca_device *gspca_dev)
{
	struct usb_device *dev = gspca_dev->dev;
	__u8 i2c1[] = { 0xA1, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x14 };
	int i = 0;
	while (pas106_data[i][0]) {
		memcpy(&i2c1[2], &pas106_data[i++][0], 2);	//copy 2 bytes from the template
		if (sonix_i2cwrite(dev, i2c1, 8) < 0)
			PDEBUG(0, "i2c error pas106");
	}
	return 0;
}
static int
ov7630_I2cinit(struct gspca_device *gspca_dev)
{
	struct usb_device *dev = gspca_dev->dev;
	int i = 0;
	while (ov7630_sensor_init[i][0]) {
		if (sonix_i2cwrite(dev, ov7630_sensor_init[i], 8) < 0)
			PDEBUG(0, "i2c error ov7630");
		i++;
	}
	return 0;
}
static int
tas5110_I2cinit(struct gspca_device *gspca_dev)
{
	struct usb_device *dev = gspca_dev->dev;
	int i = 0;
	while (tas5110_sensor_init[i][0]) {
		if (sonix_i2cwrite(dev, tas5110_sensor_init[i], 8) < 0)
			PDEBUG(0, "i2c error tas5110");
		i++;
	}
	return 0;
}
static int
hv7131_I2cinit(struct gspca_device *gspca_dev)
{
	struct usb_device *dev = gspca_dev->dev;
	int i = 0;
	while (hv7131_sensor_init[i][0]) {
		if (sonix_i2cwrite(dev, hv7131_sensor_init[i], 8) < 0)
			PDEBUG(0, "i2c error hv7131");
		i++;
	}
	return 0;
}
static int
pas202_I2cinit(struct gspca_device *gspca_dev)
{
	struct usb_device *dev = gspca_dev->dev;
	int i = 0;
	while (pas202_sensor_init[i][0]) {
		if (sonix_i2cwrite(dev, pas202_sensor_init[i], 8) < 0)
			PDEBUG(0, "i2c error pas202");
		i++;
	}
	return 0;
}
static void
sonix_start(struct gspca_device *gspca_dev)
{
struct usb_device *dev = gspca_dev->dev;
	__u8 compress = 0;
	__u8 MCK_SIZE = 0x33;
	__u8 frmult = 0x28;
	__u8 *sn9c10x = NULL;
	__u8 CompressCtrl[] = { 0, 0 };
	int err = 0;
	switch (gspca_dev->sensor) {
	case SENSOR_OV7630:
		sn9c10x = initOv7630;
		compress = gspca_dev->mode << 4 | COMP2;
		CompressCtrl[0] = compress;
		frmult = 0x68;
		CompressCtrl[1] = 0x20;
		MCK_SIZE = 0x20;
		break;
	case SENSOR_TAS5130C:
		sn9c10x = initTas5130;
		compress = gspca_dev->mode << 4 | COMP;
		CompressCtrl[0] = compress;
		frmult = 0x60;
		switch (gspca_dev->mode) {
		case 0:	/* 640x480 3fp/s */
			CompressCtrl[1] = 0x43;	//0xA3 3fp/s ;// 0xF3;
			MCK_SIZE = 0x43;	// 0xA3;//0xF3;
			break;
		case 1:	/* 320x240 0x33 10fp/s */
			CompressCtrl[1] = 0x23;
			MCK_SIZE = 0x23;
			break;
		case 2:	/* 160x120 15fp/s */
			CompressCtrl[1] = 0x23;
			MCK_SIZE = 0x23;
			break;
		default:
			break;
		}
		break;
	case SENSOR_PAS106:
		sn9c10x = initPas106;;
		compress = gspca_dev->mode << 4 | COMP1;
		CompressCtrl[0] = compress;
		frmult = 0x24;	//0x28
		CompressCtrl[1] = 0x20;	//0xF3;
		MCK_SIZE = 0x20;	//0xF3;
		break;
	case SENSOR_TAS5110:
		sn9c10x = initTas5110;
		compress = gspca_dev->mode << 4 | 0x86;
		CompressCtrl[0] = compress;
		frmult = 0x60;
		CompressCtrl[1] = 0x2b;	//0xF3;
		MCK_SIZE = 0x2b;	//0xF3;
		break;
	case SENSOR_HV7131R:
		sn9c10x = initHv7131;
		compress = gspca_dev->mode << 4 | 0x8a;
		CompressCtrl[0] = compress;
		frmult = 0x60;
		CompressCtrl[1] = 0x20;
		MCK_SIZE = 0x20;
		break;
	case SENSOR_PAS202:
		sn9c10x = initPas202;
		compress = gspca_dev->mode << 4 | 0x89;
		CompressCtrl[0] = compress;
		frmult = 0x20;	//reg17 // 7 fp/s VGA
		if (gspca_dev->mode)
			frmult = 0x24;	// 0x28->11fp/s SIF 0x24
		CompressCtrl[1] = 0x20;	//reg19 30
		MCK_SIZE = 0x20;
		break;
	}
	/* reg 0x01 bit 2 video transfert on */

	sonixRegWrite(dev, 0x08, 0x01, 0x0000, &sn9c10x[0], 1);
	/* reg 0x17 SensorClk enable inv Clk 0x60 */
	sonixRegWrite(dev, 0x08, 0x17, 0x0000, &sn9c10x[0x17 - 1], 1);
	/* Set the whole registers from the template */
	sonixRegWrite(dev, 0x08, 0x01, 0x0000, sn9c10x, 0x1f);
	switch (gspca_dev->sensor) {
	case SENSOR_TAS5130C:
		err = tas5130_I2cinit(gspca_dev);
		break;
	case SENSOR_PAS106:
		err = pas106_I2cinit(gspca_dev);
		break;
	case SENSOR_OV7630:
		err = ov7630_I2cinit(gspca_dev);
		break;
	case SENSOR_HV7131R:
		err = hv7131_I2cinit(gspca_dev);
		break;
	case SENSOR_TAS5110:
		err = tas5110_I2cinit(gspca_dev);
		break;
	case SENSOR_PAS202:
		err = pas202_I2cinit(gspca_dev);
		break;
	default:
		err = -EINVAL;
		break;
	}
	/* H_size V_size  0x28,0x1e maybe 640x480 */
	sonixRegWrite(dev, 0x08, 0x15, 0x0000, &sn9c10x[0x15 - 1],
		      0x02);
	/* compression register */
	sonixRegWrite(dev, 0x08, 0x18, 0x0000, &compress, 1);
	// H_start      
	sonixRegWrite(dev, 0x08, 0x12, 0x0000, &sn9c10x[0x12 - 1], 1);
	// V_START      
	sonixRegWrite(dev, 0x08, 0x13, 0x0000, &sn9c10x[0x13 - 1], 1);
	/* re set 0x17 SensorClk enable inv Clk 0x60 */
	sonixRegWrite(dev, 0x08, 0x17, 0x0000, &frmult, 1);
	/*MCKSIZE ->3 */
	sonixRegWrite(dev, 0x08, 0x19, 0x0000, &MCK_SIZE, 1);
	/* AE_STRX AE_STRY AE_ENDX AE_ENDY */
	sonixRegWrite(dev, 0x08, 0x1c, 0x0000, &sn9c10x[0x1c - 1], 4);
	/* Enable video transfert */
	sonixRegWrite(dev, 0x08, 0x01, 0x0000, &sn9c10x[0], 1);
	/* Compression */
	sonixRegWrite(dev, 0x08, 0x18, 0x0000, CompressCtrl, 2);

	sonix_setcontrast(gspca_dev);
	sonix_setbrightness(gspca_dev);

}
static int
sonix_config(struct gspca_device *gspca_dev)
{
struct stream_camera *camera = &gspca_dev->camera;
	camera->epaddr = 0x01;
	camera->transfert = USB_ENDPOINT_XFER_ISOC;
	if (camera->customid == SN9C102P || camera->customid == SN9C105
	    || camera->customid == SN9C120){
		camera->type = JPGS;
		gspca_dev->stream_param.qindex = 4;	//set the quantization table
	} else 
		camera->type = SN9C;
	switch (gspca_dev->sensor) {
	case SENSOR_OV7630:
	case SENSOR_TAS5130C:
	case SENSOR_HV7131R:
	case SENSOR_MI0360:
	case SENSOR_PAS202:
		set_sonixVGA(gspca_dev);
		break;
	case SENSOR_PAS106:
	case SENSOR_TAS5110:
		set_sonixSIF(gspca_dev);
		break;
	default:
		return -EINVAL;
		break;
	}
	
	return sonix_initcontrol(gspca_dev);
}
static void
sonix_stopN(struct gspca_device *gspca_dev)
{
struct usb_device *dev = gspca_dev->dev;
	__u8 ByteSend = 0;

	ByteSend = 0x09;	// 0X00
	sonixRegWrite(dev, 0x08, 0x01, 0x0000, &ByteSend, 1);
}
static int
sonix_sofdetect(struct gspca_device *gspca_dev, struct gspca_rawframe *frame,
		unsigned char *cdata, int *iPix, int seqnum, int *datalength)
{

	int sof = 0;
	int j = 0;
	int p = 0;

	if (*datalength < 24) {
		if (*datalength > 6) {
			j = *datalength - 6;
		} else {
			j = 0;
		}
		if (j > 0) {
			for (p = 0; p < j; p++) {
				if ((cdata[0 + p] == 0xFF)
				    && (cdata[1 + p] == 0xFF)
				    && (cdata[2 + p] == 0x00)
				    && (cdata[3 + p] == 0xC4)
				    && (cdata[4 + p] == 0xC4)
				    && (cdata[5 + p] == 0x96)) {
					sof = 1;
					break;
				}
			}
		}
	}
	if (sof) {
		*iPix = p + 12;
		*datalength -= *iPix;
		return 0;
		PDEBUG(5,
		       "Sonix header packet found %d datalength %d !!",
		       p, *datalength);
	} else
		*iPix = 0;
	return seqnum + 1;
}
static int 
gspca_attach_sonix(struct gspca_device *gspca_dev)
{
	if (gspca_dev->bridge == BRIDGE_SN9CXXX){
	
	info("USB GSPCA camera found.(SN9CXXX) ");
	memcpy(&gspca_dev->funct, &fsn9cxx, sizeof (struct cam_operation));
	} else {
	info("USB GSPCA camera found.(SN9C10X) ");
	memcpy(&gspca_dev->funct, &fsonix, sizeof (struct cam_operation));
	}
return 0;
}
static int gspca_check_sonix(struct gspca_device *gspca_dev,__u16 vendor,__u16 product)
{
struct stream_camera *camera = &gspca_dev->camera;
	switch(vendor){	
		case VENDOR_PHILIPS :
			switch(product){
			case 0x0328:
			gspca_dev->desc = PhilipsSPC700NC;
			gspca_dev->sensor = SENSOR_MI0360;
			camera->customid = SN9C105;
			camera->i2c_ctrl_reg = 0x81;
			camera->i2c_base = 0x5d;
			break;
			case 0x0327:
			gspca_dev->desc = PhilipsSPC600NC;
			gspca_dev->sensor = SENSOR_MI0360;
			camera->customid = SN9C105;
			camera->i2c_ctrl_reg = 0x81;
			camera->i2c_base = 0x5d;
			break;
		break;
		case VENDOR_SONIX :
			switch(product){
			case 0x6001:
			gspca_dev->desc = GeniusVideoCamNB;
			gspca_dev->sensor = SENSOR_TAS5110;
			camera->customid = SN9C102;
			camera->i2c_ctrl_reg = 0x20;
			camera->i2c_base = 0x11;
			break;
			case 0x6007:
			case 0x6005:
			gspca_dev->desc = SweexTas5110;
			gspca_dev->sensor = SENSOR_TAS5110;
			camera->customid = SN9C101;
			camera->i2c_ctrl_reg = 0x20;
			camera->i2c_base = 0x11;
			break;
			case 0x6024:
			case 0x6025:
			gspca_dev->desc = Sonix6025;
			gspca_dev->sensor = SENSOR_TAS5130C;
			camera->customid = SN9C102;
			camera->i2c_ctrl_reg = 0x20;
			camera->i2c_base = 0x11;
			break;
			case 0x6028:
			gspca_dev->desc = BtcPc380;
			gspca_dev->sensor = SENSOR_PAS202;
			camera->customid = SN9C102;
			camera->i2c_ctrl_reg = 0x80;
			camera->i2c_base = 0x40;
			break;
			case 0x6019:
			gspca_dev->desc = Sonix6019;
			gspca_dev->sensor = SENSOR_OV7630;
			camera->customid = SN9C101;
			camera->i2c_ctrl_reg = 0x80;
			camera->i2c_base = 0x21;
			break;
			case 0x602c:
			case 0x602e:
			gspca_dev->desc = GeniusVideoCamMessenger;
			gspca_dev->sensor = SENSOR_OV7630;
			camera->customid = SN9C102;
			camera->i2c_ctrl_reg = 0x80;
			camera->i2c_base = 0x21;
			break;
			case 0x602d:
			gspca_dev->desc = Lic200;
			gspca_dev->sensor = SENSOR_HV7131R;
			camera->customid = SN9C102;
			camera->i2c_ctrl_reg = 0x80;
			camera->i2c_base = 0x11;
			break;
			case 0x6009:
			case 0x600d:
			case 0x6029:
			gspca_dev->desc = Sonix6029;
			gspca_dev->sensor = SENSOR_PAS106;
			camera->customid = SN9C101;
			camera->i2c_ctrl_reg = 0x81;
			camera->i2c_base = 0x40;
			break;
			case 0x6040:
			gspca_dev->desc = SpeedNVC350K;
			gspca_dev->sensor = SENSOR_HV7131R;
			camera->customid = SN9C102P;
			camera->i2c_ctrl_reg = 0x81;
			camera->i2c_base = 0x11;
			break;
			case 0x607c:
			gspca_dev->desc = SonixWC311P;
			gspca_dev->sensor = SENSOR_HV7131R;
			camera->customid = SN9C102P;
			camera->i2c_ctrl_reg = 0x81;
			camera->i2c_base = 0x11;
			break;
			case 0x613c:
			gspca_dev->desc = Pccam168;
			gspca_dev->sensor = SENSOR_HV7131R;
			camera->customid = SN9C120;
			camera->i2c_ctrl_reg = 0x81;
			camera->i2c_base = 0x11;
			break;
			case 0x6130:
			gspca_dev->desc = Pccam;
			gspca_dev->sensor = SENSOR_MI0360;
			camera->customid = SN9C120;
			camera->i2c_ctrl_reg = 0x81;
			camera->i2c_base = 0x5d;
			break;
			case 0x60c0:
			gspca_dev->desc = Sn535;
			gspca_dev->sensor = SENSOR_MI0360;
			camera->customid = SN9C105;
			camera->i2c_ctrl_reg = 0x81;
			camera->i2c_base = 0x5d;
			break;
			case 0x60fc:
			gspca_dev->desc = Lic300;
			gspca_dev->sensor = SENSOR_HV7131R;
			camera->customid = SN9C105;
			camera->i2c_ctrl_reg = 0x81;
			camera->i2c_base = 0x11;
			break;
		break;	
	}
switch (camera->customid){
	case SN9C105:
	case SN9C120:
	case SN9C102P:
		gspca_dev->bridge = BRIDGE_SN9CXXX;
	break;
	case SN9C101:
	case SN9C102:
	case SN9C103:
		gspca_dev->bridge = BRIDGE_SONIX;
	break;
	default:
		return 0;
}	
return product;
}

#endif				/* SONIXUSB_H */
