static int
gspca_check_vimicro(struct gspca_device *gspca_dev, __u16 vendor, __u16 product)
{
	switch (vendor) {
	case VENDOR_VIMICRO:
		switch (product) {
		case 0x301b:	/* Wasam 350r */
			gspca_dev->desc = Vimicro;
			goto the_end;
		case 0x303b:	/* Wasam 350r */
			gspca_dev->desc = Vimicro303b;
			goto the_end;
		case 0x305b:	/* Generic */
			gspca_dev->desc = Zc0305b;
			goto the_end;
		case 0x0302:	/* Generic */
			gspca_dev->desc = Zc302;
			goto the_end;
		}
		break;
	case VENDOR_LOGITECH:
		switch (product) {
		case 0x08a0:
			gspca_dev->desc = QCim;
			goto the_end;
		case 0x08a1:
			gspca_dev->desc = QCimA1;
			goto the_end;
		case 0x08a2:	// zc302 chips 
			gspca_dev->desc = LabtecPro;
			goto the_end;
		case 0x08a3:
			gspca_dev->desc = QCchat;
			goto the_end;
		case 0x08a6:
			gspca_dev->desc = LogitechQCim;
			goto the_end;
		case 0x08a7:
			gspca_dev->desc = LogitechQCImage;
			goto the_end;
		case 0x08a9:
			gspca_dev->desc = LogitechNotebookDeluxe;
			goto the_end;
		case 0x08ae:
			gspca_dev->desc = QuickCamNB;
			goto the_end;
		case 0x08ac:
			gspca_dev->desc = LogitechQCCool;
			goto the_end;
		case 0x08ad:
			gspca_dev->desc = LogitechQCCommunicateSTX;
			goto the_end;
		case 0x08aa:
			gspca_dev->desc = LabtecNotebook;
			goto the_end;
		case 0x08b9:
			gspca_dev->desc = QCimB9;
			goto the_end;
		case 0x08d9:
			gspca_dev->desc = QCimconnect;
			goto the_end;
		case 0x08da:
			gspca_dev->desc = QCmessenger;
			goto the_end;
		}
		break;
	case VENDOR_CREATIVE:
		switch (product) {
		case 0x401c:	// zc301 chips 
			gspca_dev->desc = CreativeNX;
			goto the_end;
		case 0x401e:	// zc301 chips 
			gspca_dev->desc = CreativeNxPro;
			goto the_end;
		case 0x4034:	// zc301 chips 
			gspca_dev->desc = CreativeInstant1;
			goto the_end;
		case 0x4035:	// zc301 chips 
			gspca_dev->desc = CreativeInstant2;
			goto the_end;
		case 0x403a:
			gspca_dev->desc = CreativeNxPro2;
			goto the_end;
		case 0x4036:
			gspca_dev->desc = CreativeLive;
			goto the_end;
		case 0x401f:	// zc301 chips 
			gspca_dev->desc = CreativeNotebook;
			goto the_end;
		case 0x4017:	// zc301 chips 
			gspca_dev->desc = CreativeMobile;
			goto the_end;
		}
		break;
	case VENDOR_PHILIPS:
		switch (product) {
		case 0x0325:	/* Low cost Philips Webcam */
			gspca_dev->desc = PhilipsSPC200NC;
			goto the_end;
		case 0x0326:	/* Low cost Philips Webcam */
			gspca_dev->desc = PhilipsSPC300NC;
			goto the_end;
		}
		break;
	case VENDOR_MUSTEK:
		switch (product) {
		case 0xc005:	// zc302 chips 
			gspca_dev->desc = Wcam300A;
			goto the_end;
		case 0xd003:	// zc302 chips 
			gspca_dev->desc = MustekWcam300A;
			goto the_end;
		case 0xd004:	// zc302 chips 
			gspca_dev->desc = WCam300AN;
			goto the_end;
		}
		break;
	case VENDOR_GENIUS:
		switch (product) {
		case 0x7007:	// zc301 chips 
			gspca_dev->desc = GeniusVideoCamV2;
			goto the_end;
		case 0x700c:	// zc301 chips 
			gspca_dev->desc = GeniusVideoCamV3;
			goto the_end;
		case 0x700f:	// zc301 chips 
			gspca_dev->desc = GeniusVideoCamExpressV2b;
			goto the_end;
		}
		break;
	case VENDOR_UINOVATION:
		switch (product) {
		case 0x0a00:	// zc301 chips 
			gspca_dev->desc = WebCam320;
			goto the_end;
		}
		break;
	case VENDOR_FLYCAM:
		switch (product) {
		case 0x0128:
		case 0x8050:	// zc301 chips
			gspca_dev->desc = TyphoonWebshotIIUSB300k;
			goto the_end;
		}
		break;
	case VENDOR_CTX:
		switch (product) {
		case 0x2003:	/* The Webcam built in the CTX M730V TFT-Display, behind an USB-HUB */
			gspca_dev->desc = CTXM730VCam;
			goto the_end;
		}
		break;
	}
	return 0;
      the_end:
	gspca_dev->bridge = BRIDGE_ZC3XX;
	return product;
}
